SystemOrganization addCategory: #'HV-base'!
SystemOrganization addCategory: #'HV-examples'!

Notification subclass: #HVResponseNotification
	instanceVariableNames: 'response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVResponseNotification class methodsFor: 'as yet unclassified' stamp: 'gk 3/3/2004 16:33'!
signal: aResponse
	^(self new response: aResponse) signal! !

!HVResponseNotification methodsFor: 'as yet unclassified' stamp: 'gk 3/3/2004 16:34'!
response
	^response! !

!HVResponseNotification methodsFor: 'as yet unclassified' stamp: 'gk 3/3/2004 16:34'!
response: aResponse
	response _ aResponse! !

!MIMEDocument class methodsFor: '*hv-fixes' stamp: 'gh 8/30/2002 10:21'!
contentTypeTextCSS
	^'text/css'! !

WVHtmlElement subclass: #HVHtmlElement
	instanceVariableNames: 'prefix suffix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlElement commentStamp: 'gk 12/16/2003 16:54' prior: 0!
Base class for all HV elements, adds a few noncrucial facilities.!

HVHtmlElement subclass: #HVHtmlDiv
	instanceVariableNames: 'class id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlDiv class methodsFor: 'instance creation' stamp: 'gh 10/18/2002 13:34'!
class: aString
	^self new class: aString! !

!HVHtmlDiv class methodsFor: 'instance creation' stamp: 'gh 10/18/2002 13:34'!
id: anId
	^self new id: anId! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gh 10/18/2002 13:34'!
class
	^class! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gh 10/18/2002 13:34'!
class: aString
	class _ aString! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gh 10/18/2002 13:33'!
id
	^id! !

!HVHtmlDiv methodsFor: 'accessing' stamp: 'gh 10/18/2002 13:33'!
id: anId
	id _ anId! !

!HVHtmlDiv methodsFor: 'rendering' stamp: 'gh 10/18/2002 13:32'!
renderEndOn: stream

	stream nextPutAll: '</div>'! !

!HVHtmlElement methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:25'!
doPrintHtmlOn: aStream
	"Default is the implementation in super."

	super printHtmlOn: aStream! !

!HVHtmlElement methodsFor: 'decorations' stamp: 'gk 10/31/2003 11:24'!
error: aString
	"Add <aString> formatted as an error in bold red as suffix."

	self suffix: '&nbsp;<b><font color="red">', aString, '</font></b>'! !

!HVHtmlElement methodsFor: 'testing' stamp: 'gh 2/15/2002 14:41'!
isForm
	^false! !

!HVHtmlElement methodsFor: 'testing' stamp: 'gk 12/16/2003 17:24'!
isRadio
	^false! !

!HVHtmlElement methodsFor: 'accessing' stamp: 'gh 8/3/2002 02:22'!
prefix: aString
	prefix _ aString! !

!HVHtmlElement methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:25'!
printHtmlOn: aStream
	"Any prefix/suffix is added if they are not nil."

	prefix ifNotNil: [aStream nextPutAll: prefix].
	self doPrintHtmlOn: aStream.
	suffix ifNotNil: [aStream nextPutAll: suffix]! !

!HVHtmlElement methodsFor: 'decorations' stamp: 'gh 8/3/2002 02:23'!
success: aString
	"Add <aString> formatted as a message in bold green as suffix."

	suffix _ '&nbsp;<b><font color="green">', aString, '</font></b>'! !

!HVHtmlElement methodsFor: 'accessing' stamp: 'gh 8/3/2002 02:22'!
suffix: aString
	suffix _ aString! !

HVHtmlElement subclass: #HVHtmlForm
	instanceVariableNames: 'action enctype method elements id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlForm commentStamp: 'gk 10/31/2003 13:12' prior: 0!
A Form.This object has a method for rendering and it keeps track of the ids of the fields in the form. Typically only used internally in HttpView.!

!HVHtmlForm class methodsFor: 'instance creation' stamp: 'gk 12/16/2003 16:40'!
getAction: action

	^self new action: action method: 'get'! !

!HVHtmlForm class methodsFor: 'instance creation' stamp: 'gk 12/16/2003 16:39'!
postAction: action

	^self new action: action method: 'post'! !

!HVHtmlForm class methodsFor: 'instance creation' stamp: 'gk 12/16/2003 16:39'!
postAction: action enctype: type

	^self new action: action method: 'post'; enctype: type! !

!HVHtmlForm methodsFor: 'initialize-release' stamp: 'gk 12/16/2003 16:39'!
action: anAction method: aMethod

	action _ anAction.
	method _ aMethod.
	elements _ OrderedCollection new! !

!HVHtmlForm methodsFor: 'elements' stamp: 'gk 12/17/2003 11:46'!
addInput: anHtmlElement
	^elements add: anHtmlElement! !

!HVHtmlForm methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:26'!
doPrintHtmlOn: stream

	"Change this to printOpenTagOn: later"
	stream
		nextPutAll: '<form action="';
		nextPutAll: action;
		nextPutAll: '" method="', method, '"'.
	enctype ifNotNil: [stream nextPutAll: ' enctype="', enctype, '"'].
	stream nextPut: $>.
	self childrenDo: [:ea | ea printHtmlOn: stream].
	stream nextPutAll: '</form>'

"	self printCloseTagOn: stream"! !

!HVHtmlForm methodsFor: 'accessing' stamp: 'gh 10/3/2002 17:29'!
enctype
	^enctype! !

!HVHtmlForm methodsFor: 'accessing' stamp: 'gh 10/3/2002 17:29'!
enctype: type
	enctype _ type! !

!HVHtmlForm methodsFor: 'accessing' stamp: 'gh 5/14/2002 10:28'!
id
	^id! !

!HVHtmlForm methodsFor: 'accessing' stamp: 'gh 5/14/2002 10:28'!
id: anId
	id _ anId! !

!HVHtmlForm methodsFor: 'testing' stamp: 'gk 10/31/2003 13:14'!
ifSubmit: aBlock
	"Should not be used."

	0 halt.! !

!HVHtmlForm methodsFor: 'testing' stamp: 'gh 2/15/2002 14:41'!
isForm
	^true! !

!HVHtmlForm methodsFor: 'elements' stamp: 'gk 10/31/2003 13:13'!
nextVarName
	"We take our own numeric id and tack on a numeric id for our elements."

	^(id fullPrintString, '-',  (elements size + 1) fullPrintString) asSymbol! !

HVHtmlElement subclass: #HVHtmlImage
	instanceVariableNames: 'url alt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlImage class methodsFor: 'instance creation' stamp: 'gk 11/7/2003 11:41'!
url: imageUrl alt: description

	^self new url: imageUrl alt: description! !

!HVHtmlImage methodsFor: 'accessing' stamp: 'gk 11/7/2003 11:44'!
alt
	^alt! !

!HVHtmlImage methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:26'!
doPrintHtmlOn: stream
	"Render the image in valid XHTML. The alt tag is mandatory
	in XHTML and the tag needs to end with a slash."

	stream nextPutAll: '<img'.
	stream nextPutAll: ' src="', url, '" alt="', (self alt ifNil: ['no description']), '"'.
	self renderAttributesOn: stream.
	stream nextPutAll: ' />'! !

!HVHtmlImage methodsFor: 'rendering' stamp: 'gk 11/7/2003 11:50'!
renderAttributesOn: stream
	"Render attributes. More?"! !

!HVHtmlImage methodsFor: 'accessing' stamp: 'gk 11/7/2003 11:49'!
url
	^url! !

!HVHtmlImage methodsFor: 'initialize-release' stamp: 'gk 11/7/2003 11:49'!
url: aURL alt: aString

	url _ aURL.
	alt _ aString! !

HVHtmlElement subclass: #HVHtmlVariable
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlVariable commentStamp: 'gh 6/12/2002 10:54' prior: 0!
An abstract base class for elements that has a name and carry a value.

Can be used to embed dynamic values in HTML pages (subclass HVSimpleVariable) but it is also the base class for all Form elements like input fields etc.!

HVHtmlVariable subclass: #HVHtmlFormElement
	instanceVariableNames: 'readonly disabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlFormElement methodsFor: 'decorations' stamp: 'gk 8/8/2003 17:20'!
clearDisabled
	disabled _ nil! !

!HVHtmlFormElement methodsFor: 'decorations' stamp: 'gk 8/8/2003 17:21'!
clearReadonly
	readonly _ nil! !

!HVHtmlFormElement methodsFor: 'rendering' stamp: 'gk 8/8/2003 16:55'!
renderAttributesOn: stream
	"Render attributes."

	readonly ifNotNil: [stream nextPutAll: ' readonly'].
	disabled ifNotNil: [stream nextPutAll: ' disabled']! !

!HVHtmlFormElement methodsFor: 'decorations' stamp: 'gk 8/8/2003 16:57'!
setDisabled
	disabled _ true! !

!HVHtmlFormElement methodsFor: 'decorations' stamp: 'gk 8/8/2003 16:57'!
setReadonly
	readonly _ true! !

HVHtmlFormElement subclass: #HVHtmlInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInput commentStamp: 'gh 6/12/2002 10:48' prior: 0!
Base class for all input elements, inherits the ability to carry a "value" and a "name" from HVHtmlVariable. Basic rendering.!

!HVHtmlInput methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:25'!
doPrintHtmlOn: stream

	stream nextPutAll: '<input'.
	stream nextPutAll: ' type="', self renderType, '" name="', name, '"'.
	self renderAttributesOn: stream.
	self renderValueOn: stream.
	stream nextPutAll: ' />'! !

!HVHtmlInput methodsFor: 'accessing' stamp: 'gk 8/8/2003 16:22'!
readonly
	^readonly! !

!HVHtmlInput methodsFor: 'rendering' stamp: 'gh 4/3/2002 13:20'!
renderValueOn: stream

	stream nextPutAll: ' value="', value asString, '"'.! !

!HVHtmlInput methodsFor: 'accessing' stamp: 'gk 8/8/2003 16:22'!
setReadonly
	readonly _ true! !

HVHtmlInput subclass: #HVHtmlInputCheckbox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputCheckbox commentStamp: 'gh 6/12/2002 10:47' prior: 0!
A Form checkbox. Simply a method for rendering.!

!HVHtmlInputCheckbox methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:43'!
renderType
	^'checkbox'! !

!HVHtmlInputCheckbox methodsFor: 'rendering' stamp: 'gk 5/18/2004 14:34'!
renderValueOn: stream
	value ifTrue:[stream nextPutAll: ' checked="checked"']! !

HVHtmlInputCheckbox subclass: #HVHtmlInputRadio
	instanceVariableNames: 'id closed previous'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputRadio commentStamp: 'gk 11/11/2003 11:00' prior: 0!
A Form radio button. Like a check box but several sharing the same name are enforced to be mutually exclusive. One is always checked.!

!HVHtmlInputRadio class methodsFor: 'instance-creation' stamp: 'gk 11/11/2003 12:44'!
name: aName value: aValue id: anId
	^super new name: aName value: aValue id: anId; yourself! !

!HVHtmlInputRadio methodsFor: 'accessing' stamp: 'gk 12/16/2003 17:25'!
close
	closed _ true! !

!HVHtmlInputRadio methodsFor: 'accessing' stamp: 'gk 12/17/2003 13:30'!
id
	^id! !

!HVHtmlInputRadio methodsFor: 'testing' stamp: 'gk 12/16/2003 17:25'!
isClosed
	^closed! !

!HVHtmlInputRadio methodsFor: 'testing' stamp: 'gk 12/16/2003 17:24'!
isRadio
	^true! !

!HVHtmlInputRadio methodsFor: 'initialize-release' stamp: 'gk 12/16/2003 17:25'!
name: aName value: aValue id: anId
	super name: aName value: aValue.
	closed _ false.
	id _ anId! !

!HVHtmlInputRadio methodsFor: 'testing' stamp: 'gk 12/17/2003 13:32'!
nooneSet
	"Is none of the previous radios set to true including me?"

	^previous ifNil: [value not]
		ifNotNil: [previous nooneSet and: [value not]]! !

!HVHtmlInputRadio methodsFor: 'accessing' stamp: 'gk 12/16/2003 17:28'!
previous
	^previous! !

!HVHtmlInputRadio methodsFor: 'accessing' stamp: 'gk 12/16/2003 17:28'!
previous: aRadio
	previous _ aRadio! !

!HVHtmlInputRadio methodsFor: 'rendering' stamp: 'gk 11/11/2003 11:00'!
renderType
	^'radio'! !

!HVHtmlInputRadio methodsFor: 'rendering' stamp: 'gk 12/16/2003 17:36'!
renderValueOn: stream
	"We use the id as the value instead."

	stream nextPutAll: ' value="', id asString, '" '.
	super renderValueOn: stream! !

HVHtmlInput subclass: #HVHtmlInputFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputFile methodsFor: 'rendering' stamp: 'gh 10/3/2002 17:49'!
renderType

	^'file'! !

HVHtmlInput subclass: #HVHtmlInputHidden
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputHidden commentStamp: 'gh 6/12/2002 10:49' prior: 0!
Simply a hidden field.!

!HVHtmlInputHidden methodsFor: 'as yet unclassified' stamp: 'gh 3/16/2002 00:27'!
renderType

	^'hidden'! !

HVHtmlInput subclass: #HVHtmlInputSubmit
	instanceVariableNames: 'pressed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputSubmit commentStamp: 'gh 6/12/2002 10:50' prior: 0!
A submit button for a Form.!

!HVHtmlInputSubmit class methodsFor: 'instance creation' stamp: 'gk 10/29/2003 15:19'!
name: aName value: val pressed: pressed
	^(super name: aName value: val) pressed: pressed! !

!HVHtmlInputSubmit methodsFor: 'control' stamp: 'gk 10/29/2003 15:37'!
ifPressed: aBlock
	"Evaluate <aBlock> if this button was pressed -
	if the name of the button was submitted."

	^pressed ifTrue: [aBlock value]! !

!HVHtmlInputSubmit methodsFor: 'control' stamp: 'gk 10/31/2003 10:09'!
ifPressed: aBlock ifNot: anotherBlock
	"Evaluate <aBlock> if this button was pressed -
	if the name of the button was submitted.
	If not we evaluate <anotherBlock>."

	^pressed ifTrue: [aBlock value] ifFalse: [anotherBlock value]! !

!HVHtmlInputSubmit methodsFor: 'control' stamp: 'gk 5/5/2004 15:01'!
isPressed
	"Was this button pressed?"

	^pressed! !

!HVHtmlInputSubmit methodsFor: 'accessing' stamp: 'gk 10/29/2003 15:37'!
pressed
	^pressed! !

!HVHtmlInputSubmit methodsFor: 'accessing' stamp: 'gk 10/29/2003 15:36'!
pressed: aBoolean
	pressed _ aBoolean! !

!HVHtmlInputSubmit methodsFor: 'rendering' stamp: 'gh 5/14/2002 10:40'!
renderType
	^'submit'! !

HVHtmlInput subclass: #HVHtmlInputText
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputText commentStamp: 'gh 6/12/2002 10:50' prior: 0!
A text input field for Forms.!

HVHtmlInputText subclass: #HVHtmlInputNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputNumber commentStamp: 'gh 6/12/2002 10:49' prior: 0!
A special variant of HVHtmlInputText that returns a number.!

!HVHtmlInputNumber methodsFor: 'accessing' stamp: 'gh 3/16/2002 00:58'!
value
	^super value asNumber! !

!HVHtmlInputNumber methodsFor: 'accessing' stamp: 'gh 3/16/2002 00:58'!
value: aValue
	^super value: aValue fullPrintString! !

HVHtmlInputText subclass: #HVHtmlInputPassword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlInputPassword commentStamp: 'gh 6/12/2002 10:50' prior: 0!
A password field for a Form.!

!HVHtmlInputPassword methodsFor: 'rendering' stamp: 'gh 3/4/2002 17:37'!
renderType

	^'password'! !

!HVHtmlInputText class methodsFor: 'instance creation' stamp: 'gk 5/7/2004 11:15'!
name: aName value: aValue size: aSize
	^super new name: aName value: (aValue ifNil: ['']); size: aSize; yourself! !

!HVHtmlInputText methodsFor: 'rendering' stamp: 'gk 8/8/2003 16:56'!
renderAttributesOn: stream
	"Add the size attribute."

	super renderAttributesOn: stream.
	stream nextPutAll: ' size="'.
	size printOn: stream.
	stream nextPut: $"! !

!HVHtmlInputText methodsFor: 'rendering' stamp: 'gh 1/15/2002 16:43'!
renderType

	^'text'! !

!HVHtmlInputText methodsFor: 'accessing' stamp: 'gh 2/22/2002 13:15'!
size
	^size! !

!HVHtmlInputText methodsFor: 'accessing' stamp: 'gh 2/22/2002 13:15'!
size: aSize
	size _ aSize! !

HVHtmlFormElement subclass: #HVHtmlSelection
	instanceVariableNames: 'objects values labels nilLabel labelSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

HVHtmlSelection subclass: #HVHtmlRadioGroup
	instanceVariableNames: 'vertical'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlRadioGroup class methodsFor: 'instance creation' stamp: 'gk 11/11/2003 11:21'!
name: aName objects: objects values: values nilLabel: label selector: sel value: aValue 
	^super new name: aName value: aValue;
		objects: objects values: values nilLabel: label selector: sel; yourself! !

!HVHtmlRadioGroup class methodsFor: 'instance creation' stamp: 'gk 11/11/2003 11:12'!
name: aName objects: objects values: values size: size multiple: multi nilLabel: label selector: sel value: aValue 
	^super new name: aName value: aValue;
		objects: objects values: values size: size multiple: multi nilLabel: label selector: sel; yourself! !

!HVHtmlRadioGroup methodsFor: 'accessing' stamp: 'gk 12/17/2003 13:26'!
doPrintHtmlOn: stream
	"Render the radio group as HTML."

	| current |
	labels _ objects
				collect: [:obj |
					obj
						ifNil: [nilLabel]
						ifNotNil: [
							(obj isKindOf: String)
								ifTrue:[obj]
								ifFalse:[obj perform: labelSelector]]].
	1 to: objects size do: [:n |
		current _ values ifNil: [objects at: n] ifNotNil: [values at: n].
		(vertical & (n>1)) ifTrue: [stream nextPutAll: '<br />'].
		stream nextPutAll: '<input type="radio" name="', name, '" value="'.
		values
			ifNil: [n printOn: stream]
			ifNotNil: [stream nextPutAll: (values at: n) asString].
		(current = value)
			ifTrue: [stream nextPutAll: '" checked>']
			ifFalse: [stream nextPutAll: '" >' ].
		stream nextPutAll: (labels at: n).
		stream nextPutAll: '</input>'.
	]! !

!HVHtmlRadioGroup methodsFor: 'accessing' stamp: 'gk 11/11/2003 11:43'!
objects: objs values: vals nilLabel: label selector: sel
	super objects: objs values: vals nilLabel: label selector: sel.
	vertical _ false! !

!HVHtmlRadioGroup methodsFor: 'accessing' stamp: 'gk 11/11/2003 11:41'!
vertical
	^vertical! !

!HVHtmlRadioGroup methodsFor: 'accessing' stamp: 'gk 11/11/2003 11:42'!
vertical: aBoolean
	vertical _ aBoolean! !

HVHtmlSelection subclass: #HVHtmlSelect
	instanceVariableNames: 'size multiple autoSubmit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlSelect commentStamp: 'gh 6/12/2002 10:50' prior: 0!
A drop down menu.!

!HVHtmlSelect class methodsFor: 'instance creation' stamp: 'gk 8/15/2003 15:13'!
name: aName objects: objects values: values size: size multiple: multi nilLabel: label selector: sel value: aValue 
	^super new name: aName value: aValue;
		objects: objects values: values size: size multiple: multi nilLabel: label selector: sel; yourself! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 2/19/2004 15:49'!
autoSubmit: aBoolean
	autoSubmit _ aBoolean! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 5/18/2004 14:34'!
doPrintHtmlOn: stream
	"Render the select as HTML."

	| current |
	stream nextPutAll: '<select name="', name, '" size="', size printString, '"'.
	autoSubmit ifTrue: [stream nextPutAll: ' onchange="this.form.submit();"'].
	stream nextPutAll: (multiple ifTrue: [' multiple>'] ifFalse: ['>']).
	labels _ objects
				collect: [:obj |
					obj
						ifNil: [nilLabel]
						ifNotNil: [
							(obj isKindOf: String)
								ifTrue:[obj]
								ifFalse:[obj perform: labelSelector]]].
	1 to: objects size do: [:n |
		current _ values ifNil: [objects at: n] ifNotNil: [values at: n].
		((multiple and: [value notNil])
			ifTrue: [value includes: current]
			ifFalse: [current = value])
				ifTrue: [stream nextPutAll: '<option selected="selected"']
				ifFalse: [stream nextPutAll: '<option' ].
		stream nextPutAll: ' value="'.
		values ifNil: [n printOn: stream] ifNotNil: [stream nextPutAll: (values at: n) asString].
		stream nextPutAll: ' ">'.
		stream nextPutAll: (labels at: n).
		stream nextPutAll: '</option>'.
	].
	stream nextPutAll: '</select>'! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 8/15/2003 12:38'!
multiple
	^multiple! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 8/15/2003 12:39'!
multiple: aBoolean
	multiple _ aBoolean! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gk 2/19/2004 15:51'!
objects: objs values: vals size: s multiple: multi nilLabel: label selector: sel
	super objects: objs values: vals nilLabel: label selector: sel.
	size _ s.
	multiple _ multi.
	autoSubmit _ false! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 3/21/2002 14:55'!
size
	^size! !

!HVHtmlSelect methodsFor: 'accessing' stamp: 'gh 3/21/2002 14:56'!
size: aSize
	size _ aSize! !

!HVHtmlSelection methodsFor: 'accessing' stamp: 'gk 11/11/2003 15:57'!
addObject: anObject
	^objects add: anObject! !

!HVHtmlSelection methodsFor: 'accessing' stamp: 'gk 11/11/2003 11:20'!
objects
	^objects! !

!HVHtmlSelection methodsFor: 'initialize-release' stamp: 'gk 11/11/2003 11:21'!
objects: objs values: vals nilLabel: label selector: sel
	objects _ objs.
	values _ vals.
	nilLabel _ label.
	sel ifNil: [labelSelector _ #name] ifNotNil: [labelSelector _ sel]! !

!HVHtmlSelection methodsFor: 'accessing' stamp: 'gk 11/11/2003 15:57'!
removeObject: anObject
	^objects remove: anObject ifAbsent: [nil]! !

!HVHtmlSelection methodsFor: 'accessing' stamp: 'gk 11/11/2003 16:00'!
removeSelected
	^self removeObject: self value! !

!HVHtmlSelection methodsFor: 'accessing' stamp: 'gk 11/11/2003 11:19'!
selector: aSymbol
	labelSelector _ aSymbol! !

HVHtmlFormElement subclass: #HVHtmlTextArea
	instanceVariableNames: 'rows cols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlTextArea commentStamp: 'gh 6/12/2002 10:51' prior: 0!
A textarea for Forms.!

!HVHtmlTextArea class methodsFor: 'instance creation' stamp: 'gh 3/19/2002 21:01'!
name: aName rows: rows cols: cols value: aValue
	^super new name: aName value: aValue; rows: rows cols: cols; yourself! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gh 3/19/2002 21:01'!
cols
	^cols! !

!HVHtmlTextArea methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:26'!
doPrintHtmlOn: stream

	stream nextPutAll: '<textarea name="', name, '" rows="', rows asString, '" cols="', cols asString, '"'.
	self renderAttributesOn: stream.
	stream nextPut: $>; nextPutAll: (value ifNil: ['']); nextPutAll: '</textarea>'
! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gk 8/8/2003 16:21'!
readonly
	^readonly! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gh 3/19/2002 21:00'!
rows
	^rows! !

!HVHtmlTextArea methodsFor: 'private' stamp: 'gh 3/19/2002 21:00'!
rows: r cols: c
	rows _ r.
	cols _ c! !

!HVHtmlTextArea methodsFor: 'accessing' stamp: 'gk 8/8/2003 16:21'!
setReadonly
	readonly _ true! !

!HVHtmlVariable class methodsFor: 'instance creation' stamp: 'gh 2/22/2002 12:44'!
name: aName value: aValue
	^super new name: aName value: aValue; yourself! !

!HVHtmlVariable methodsFor: 'initialize-release' stamp: 'gh 2/15/2002 13:55'!
initialize
	! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:53'!
name
	^name! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:54'!
name: aName
	name _ aName! !

!HVHtmlVariable methodsFor: 'private' stamp: 'gh 2/22/2002 12:44'!
name: aName value: aValue
	name _ aName.
	value _ aValue! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:53'!
value
	^value! !

!HVHtmlVariable methodsFor: 'accessing' stamp: 'gh 2/15/2002 13:53'!
value: aVal
	value _ aVal! !

HVHtmlVariable subclass: #HVSimpleVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVSimpleVariable commentStamp: 'gh 6/12/2002 10:55' prior: 0!
The concrete subclass of HVHtmlVariable that is used for embedding simple variables in HTML pages.!

!HVSimpleVariable methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:26'!
doPrintHtmlOn: stream
	"My implementation is to just convert the value to a String."

	stream nextPutAll: value asString! !

HVSimpleVariable subclass: #HVTableOfContents
	instanceVariableNames: 'topEntries builder baseUrl openImageUrl closedImageUrl leafImageUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVTableOfContents classSide methodsFor: 'instance creation' stamp: 'gh 9/12/2002 14:07'!
name: aName value: aValue builder: aBuilder
	^super new name: aName value: aValue builder: aBuilder; yourself! !

!HVTableOfContents methodsFor: 'accessing' stamp: 'gh 9/17/2002 17:43'!
baseUrl: url
	baseUrl _ url! !

!HVTableOfContents methodsFor: 'initialize-release' stamp: 'gh 10/29/2002 09:52'!
baseUrl: base open: openDoc closed: closedDoc leaf: leafDoc
	openDoc ifNotNil: [openImageUrl _ base, openDoc fileName].
	closedDoc ifNotNil: [closedImageUrl _ base, closedDoc fileName].
	leafDoc ifNotNil: [leafImageUrl _ base, leafDoc fileName]! !

!HVTableOfContents methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:25'!
closedImageUrl
	^closedImageUrl! !

!HVTableOfContents methodsFor: 'rendering' stamp: 'gk 12/17/2003 13:27'!
doPrintHtmlOn: stream
	"Render the TOC. If we are empty we act as a simple
	variable instead."

	| expanded |
	topEntries isEmpty ifTrue:[^super printHtmlOn: stream]. "no items to render, take the value instead"
	expanded _ self expanded.
	topEntries do: [:entry |
		entry printHtmlOn: stream expanded: expanded level: 0 builder: builder]
! !

!HVTableOfContents methodsFor: 'rendering' stamp: 'gh 10/18/2002 15:37'!
expanded
	"Return all names that should be expanded.
	We retrieve the cookie and convert it to a Set of Symbols."

	| attrs toc tocSym |
	tocSym _ builder view tocSymbol.
	attrs _ builder request session attributes.
	toc _ attrs at: tocSym ifAbsent:[attrs at: tocSym put: ''].
	^((toc findTokens: $,) collect: [:s | s asSymbol]) asSet
! !

!HVTableOfContents methodsFor: 'rendering' stamp: 'gh 9/17/2002 17:40'!
fullName
	^baseUrl! !

!HVTableOfContents methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:25'!
leafImageUrl
	^leafImageUrl! !

!HVTableOfContents methodsFor: 'accessing' stamp: 'gh 9/12/2002 16:26'!
name: aName label: aLabel
	"Add a new top level entry in the TOC.
	Return the entry."

	^topEntries add: (HVTableOfContentsEntry name: aName label: aLabel parent: self)! !

!HVTableOfContents methodsFor: 'initialize-release' stamp: 'gh 10/17/2002 15:26'!
name: aName value: aValue builder: aBuilder
	topEntries _ OrderedCollection new.
	builder _ aBuilder.
	name _ aName.
	value _ aValue.
	openImageUrl _ '/static/open.gif'.
	closedImageUrl _ '/static/closed.gif'.
	leafImageUrl _ '/static/leaf.gif'! !

!HVTableOfContents methodsFor: 'initialize-release' stamp: 'gh 10/17/2002 15:26'!
open: oUrl closed: cUrl leaf: lUrl
	openImageUrl _ oUrl.
	closedImageUrl _ cUrl.
	leafImageUrl _ lUrl! !

!HVTableOfContents methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:24'!
openImageUrl
	^openImageUrl! !

!TimeStamp methodsFor: '*hv-fixes' stamp: 'gk 8/14/2003 14:44'!
printOnHTTP: aStream
	"Print receiver's date and time on aStream in HTTP format;
	'<day>, DD <mth> YYYY HH:MM:SS GMT' ->	'Thu, 01 Dec 1994 16:00:00 GMT'
	"

	aStream
		nextPutAll: (date weekday copyFrom: 1 to: 3);
		nextPutAll: ', ';
		nextPutAll: (date dayOfMonth asString padded: #left to: 2 with: $0);
		nextPut: $ ;
		nextPutAll: (date monthName copyFrom: 1 to: 3);
		nextPut: $ ;
		nextPutAll: date year asString;
		nextPut: $ .
	time printOn: aStream.
	aStream nextPutAll: ' GMT'! !

!ModSession methodsFor: '*hv-fixes' stamp: 'gk 11/6/2003 17:12'!
sessionsDo: aBlock
	"Iterate over sessions."

	^ sessions valuesDo: aBlock! !

!HttpResponse class methodsFor: '*hv-fixes' stamp: 'gk 11/3/2003 13:17'!
fromRedirect: redirect
	"Hmmm, not sure - this code is old..."

	| tmp |
	^self new
		status: #tempMoved;
		fieldAt: 'Location' put: (tmp _ redirect fullHttpUrl);
		fieldAt: 'Pragma' put: 'no-cache';
		fieldAt: 'Cache-Control' put: 'private';
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: '<head><title>Object moved</title></head>
<body><h1>Object Moved</h1>This object may be found <a HREF="', tmp,'">here</a>.</body>');
		yourself! !

!HttpResponse class methodsFor: '*hv-fixes' stamp: 'gk 10/22/2003 16:10'!
redirectTo: url
	"Create a redirection response."

	^(HttpResponse
			status: #tempMoved
			contents: 'Temporarily moved to: <A HREF="', url, '">', url, '</A>')
		fieldAt: 'Location' put: url;
		fieldAt: 'URI' put: url; yourself! !

Object subclass: #HVCascadingStyleSheet
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVCascadingStyleSheet class methodsFor: 'instance creation' stamp: 'gh 8/30/2002 10:56'!
string: aString
	^self new string: aString! !

!HVCascadingStyleSheet methodsFor: 'as yet unclassified' stamp: 'gh 10/14/2002 16:39'!
asHttpResponseTo: request

	^HttpResponse new
		status: #ok;
		contentType: MIMEDocument contentTypeTextCSS;
		contents: (ReadStream on: string);
		yourself! !

!HVCascadingStyleSheet methodsFor: 'accessing' stamp: 'gh 9/18/2002 13:18'!
string
	^string! !

!HVCascadingStyleSheet methodsFor: 'accessing' stamp: 'gh 8/30/2002 10:26'!
string: aString
	string _ aString! !

Object subclass: #HVHttpView
	instanceVariableNames: 'model'
	classVariableNames: 'UltraSafeChars HtmlEntities SafeChars'
	poolDictionaries: ''
	category: 'HV-base'!

!HVHttpView commentStamp: 'gk 10/24/2003 10:55' prior: 0!
A HVHttpView is a web user interface - it is an object that handles a HttpRequest and returns a result.

A view has a domain object as a model, and thus the HVHttpView hierarchy often typically mirrors the domain class hierarchy. It also has a reference to it's parent view which ultimately is a HVRootView.

A view is instantiated for every request which means that it does not have to care about multiple Processes (each view instance is only used by one Process - the one started to serve the request) - but since the model can be shared with other views either the model needs to care or the views needs to serialize their access to the model.

The HVRootView is not instantiated for every request - it represents the web application itself that is plugged into Komanche - so it must be written Process safe.

A view holds a reference to the request - 'req' - which it is given upon instantiation. Most of the interaction with the request is done easier through the use of an HVHtmlBuilder which has a lot of support for handling HTML Forms.

Based on the url the framework will call the method with the same name. These methods are kept by convention in the 'urls' category. If no method name is given in the url the default method #default is called. The methods should return something responds to #asHttpResponseTo:. The root view sends this message to the object returned and returns the result to Komanche which expects an HttpResponse.

String implements #asHttpResponseTo: so the simplest would be to just return a String with HTML in it. A better approach would be to use an HVHtmlBuilder. Look at the sample applications.

Finally HVHttpView includes some simple facilities for keeping track of the user and the current user account.!

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 10/24/2003 10:21'!
createModel
	"This is called when a HVRootView is created
	and no model has been specified.
	Default model is nil, override in subclass."

	^nil! !

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 10/24/2003 10:43'!
defaultAlias
	"This is called when a HVRootView is created
	and no alias has been specified.
	Default alias, override in subclass."

	^''! !

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 12/4/2003 13:39'!
defaultPort
	"This is called when a HVRootView is created
	and no port number has been specified.
	Default alias, override in subclass."

	^8080! !

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 11/13/2003 23:31'!
defaultViewClass
	"This is called when a HVRootView is created
	and no viewClass has been specified.
	Default alias, override in subclass."

	^self! !

!HVHttpView class methodsFor: 'class initialization' stamp: 'gk 10/24/2003 10:19'!
initialize
	"HVHttpView initialize"

HtmlEntities _ (Dictionary new: 128)
		at: 'amp'	put: $&;
		at: 'lt'		put: $<;
		at: 'gt'		put: $>;
		at: 'quot'	put: $";
		at: 'euro'	put: Character euro;
		yourself.

SafeChars _ Set new.
('1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ/-_()".,''@?!!:; ', '﻿åäöÅÄÖéüèáêôâ') do: [:c | SafeChars add: c].
UltraSafeChars _ SafeChars copy.
UltraSafeChars remove: $/; remove: $.



	"#('nbsp' 'iexcl' 'cent' 'pound' 'curren' 'yen' 'brvbar' 'sect' 'uml' 'copy' 'ordf' 'laquo' 'not' 'shy' 'reg' 'hibar' 'deg' 'plusmn' 'sup2' 'sup3' 'acute' 'micro' 'para' 'middot' 'cedil' 'sup1' 'ordm' 'raquo' 'frac14' 'frac12' 'frac34' 'iquest' 'Agrave' 'Aacute' 'Acirc' 'Atilde' 'Auml' 'Aring' 'AElig' 'Ccedil' 'Egrave' 'Eacute' 'Ecirc' 'Euml' 'Igrave' 'Iacute' 'Icirc' 'Iuml' 'ETH' 'Ntilde' 'Ograve' 'Oacute' 'Ocirc' 'Otilde' 'Ouml' 'times' 'Oslash' 'Ugrave' 'Uacute' 'Ucirc' 'Uuml' 'Yacute' 'THORN' 'szlig' 'agrave' 'aacute' 'acirc' 'atilde' 'auml' 'aring' 'aelig' 'ccedil' 'egrave' 'eacute' 'ecirc' 'euml' 'igrave' 'iacute' 'icirc' 'iuml' 'eth' 'ntilde' 'ograve' 'oacute' 'ocirc' 'otilde' 'ouml' 'divide' 'oslash' 'ugrave' 'uacute' 'ucirc' 'uuml' 'yacute' 'thorn' 'yuml' ) withIndexDo: [:each :index | HtmlEntities at: each put: (index + 159) asCharacter isoToSqueak]"! !

!HVHttpView class methodsFor: 'instance creation' stamp: 'gk 3/2/2004 16:10'!
on: aModel
	"Create a new view on a model.
	We set the model before initializeing so that it
	can use the model."

	^super new model: aModel; initialize; yourself! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 3/3/2004 11:55'!
rootView
	"Return class to use as root view. Override to provide your own.
	Default is the generic HVRootView."

	^HVRootView! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/7/2003 10:48'!
services
	"Return all services."

	^Service services! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:06'!
start
	"Start service on default port in deployment mode."

	^self startOn: self defaultPort mode: #deployment! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:06'!
startDebug
	"Start service on default port in debug mode."

	^self startOn: self defaultPort mode: #debug! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:06'!
startDebugOn: portNum
	"Start service on port <portNum> in debug mode."

	^self startOn: portNum mode: #debug! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:11'!
startOn: portNum
	"Start service on port <portNum> in deployment mode."

	^self startOn: portNum mode: #deployment! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/13/2003 23:31'!
startOn: portNum mode: mode
	"Start service on port <portNum> in mode <mode>.
	We first create a root view that use us as default view class
	and then we start the root view."

	^(self rootView
		model: self createModel
		alias: self defaultAlias
		viewClass: self defaultViewClass)
		startOn: portNum mode: mode! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 10/24/2003 10:22'!
stop
	"Stop and unregister service with name of class."

	^(Service serviceNamed: self name) unregister! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 10/24/2003 10:23'!
stopAll
	"Stop and unregister all services."

	^Service services do: [:s | s unregister]! !

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 11/6/2003 14:51'!
useSessions
	"By default we don't."

	^false! !

!HVHttpView methodsFor: 'initialize-release' stamp: 'gk 12/19/2003 13:31'!
initialize
	"Do nothing."! !

!HVHttpView methodsFor: 'accessing' stamp: 'gk 10/24/2003 10:26'!
model
	^model! !

!HVHttpView methodsFor: 'accessing' stamp: 'gk 10/24/2003 10:26'!
model: aModel
	model _ aModel! !

!HVHttpView methodsFor: 'responses' stamp: 'gk 3/4/2004 14:31'!
redirectTo: url
	"Make a redirection to another url."

	HVResponseNotification signal:
		(HttpResponse redirectTo: (url isEmpty ifTrue:['/'] ifFalse: [url]))! !

!HVHttpView methodsFor: 'responses' stamp: 'gk 3/4/2004 14:31'!
redirectToDefault
	"Make a redirection to the default url of this view."

	^self redirectTo: self defaultUrl! !

!HVHttpView methodsFor: 'responses' stamp: 'gk 3/4/2004 14:31'!
redirectToLocal: page
	"Make a redirection to another page in this view,
	equaling another method in this class."

	^self redirectTo: (self urlFor: page)! !

HVHttpView subclass: #HVRootView
	instanceVariableNames: 'viewClass coreMod sessionMod alias selectorFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVRootView commentStamp: 'gk 10/24/2003 10:53' prior: 0!
A HVRootView is a view object that is plugged into Komanche. It holds the model and it is the first entrypoint of a web application. The method #process: is called with a HttpRequest as an argument and Komanche expects a HttpResponse being returned.

The root view typically instantiates a transient view object on the model, put the request into the view and then sends #dispatch to it.

Eventually it will return a result object that is transformed into an HttpResponse.

Simple applications typically don't subclass HVRootView, instead an instance is created when the application is started, see for example HVHttpView class>>startOn:.!

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:08'!
alias: anAlias
	"This relies on model being set in initialize."

	^self model: nil alias: anAlias viewClass: nil! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:08'!
model: aModel
	"Create a persistent root view that can be plugged into Komanche."

	^self model: aModel alias: nil viewClass: nil! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:07'!
model: aModel alias: anAlias
	"Create a persistent root view that can be plugged into Komanche."

	^self model: aModel alias: anAlias viewClass: nil! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 12/9/2003 16:10'!
model: aModel alias: anAlias viewClass: aViewClass
	"Create a persistent root view that can be plugged into Komanche."

	^(super on: aModel) alias: anAlias viewClass: aViewClass! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 3/3/2004 12:36'!
new
	"This relies on that at least model and viewClass
	is set in initialize."

	^super new initialize! !

!HVRootView class methodsFor: 'defaults' stamp: 'gk 3/3/2004 11:55'!
rootView
	"Return class to use as root view. Override to provide your own.
	Default is self."

	^self! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 3/3/2004 12:32'!
alias: anAlias viewClass: aClass
	"Default selector filter is to verify that
	the view responds to the selector and that
	it is in the method category 'urls'."

	anAlias ifNotNil: [alias _ anAlias].
	aClass ifNotNil: [viewClass _ aClass]
! !

!HVRootView methodsFor: 'dispatch' stamp: 'gk 12/19/2003 13:47'!
allowedSelector: aSelector forView: aView
	"Answer true if <aSelector> is ok to call from a URL
	to the view <aView>. Default implementation is to
	use the pluggable filter block."

	^selectorFilter value: aSelector value: aView! !

!HVRootView methodsFor: 'dispatch' stamp: 'gk 12/19/2003 13:48'!
allowedSrcSelector: aSelector forView: aView
	"Answer true if it is ok to view the source
	of <aSelector> in the view <aView>.
	Default implementation is the same as for execution."

	^self allowedSelector: aSelector forView: aView! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 3/4/2004 15:15'!
categoryOfElement: selector inClassOrSuperclass: class
	"Find first category of selector up the superclass chain."

	^class ifNotNil: [
		^(class organization categoryOfElement: selector)
			ifNil: [self categoryOfElement: selector inClassOrSuperclass: class superclass]]! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 3/4/2004 15:12'!
defaultSelectorFilter
	"Override this method to supply your own selectorFilter.
	Or plug it in using #selectorFilter:"

	^[:selector :view |
		(view respondsTo: selector) and: [
			(self categoryOfElement: selector inClassOrSuperclass: view class) = #urls]]! !

!HVRootView methodsFor: 'comanche' stamp: 'gk 3/4/2004 14:13'!
getTopView: request
	"Default way of instantiating a top view for the model.
	If the viewClass is set we use that, otherwise we try
	a double dispatch on the model using #viewFor:."

	^viewClass
		ifNotNil: [viewClass on: model parent: self]
		ifNil: [(model respondsTo: #viewFor:)
				ifTrue: [model viewFor: self]
				ifFalse: [self error: 'Do not know which view to instantiate!!']]! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 3/3/2004 12:31'!
initialize
	"Default selector filter is to verify that
	the view responds to the selector and that
	it is in the method category 'urls'."

	alias _ ''.
	selectorFilter _ self defaultSelectorFilter! !

!HVRootView methodsFor: 'views' stamp: 'gk 12/10/2003 10:24'!
parentsDo: aBlock
	"Don't have a parent, do nothing."
! !

!HVRootView methodsFor: 'views' stamp: 'gk 12/10/2003 10:25'!
parentsDoReverse: aBlock
	"Have no parent, do nothing."! !

!HVRootView methodsFor: 'comanche' stamp: 'gk 3/4/2004 14:13'!
process: request
	"Process the request. This is the method that is called by Comanche.
	Given the view we stick the request into it and let it take over.
	When the result is returned we turn it into a proper HttpResponse.
	A special notification can be signaled to return a specific response and
	bypassing the call chain."

	| view |
	view _ self getTopView: request.
	view request: request. "normally not needed when using #viewFor: but here it is"
	[^(view dispatch) asHttpResponseTo: request]
		on: HVResponseNotification do: [:ex | ^ex response]! !

!HVRootView methodsFor: 'private' stamp: 'gk 12/19/2003 00:07'!
request
	"I am the root view and do not hold the request
	because I need to be Process safe."

	^nil! !

!HVRootView methodsFor: 'views' stamp: 'gk 11/6/2003 17:26'!
rootView
	"Return the view at the root, that's me."

	^self! !

!HVRootView methodsFor: 'accessing' stamp: 'gk 12/19/2003 13:30'!
selectorFilter
	"Return the filter used in #allowedSelector:forView:"

	^selectorFilter! !

!HVRootView methodsFor: 'accessing' stamp: 'gk 12/19/2003 13:30'!
selectorFilter: aBlock
	"Set the filter used in #allowedSelector:forView:.
	It should implement #value:value: with
	the selector and the view instance as arguments."

	selectorFilter _ aBlock! !

!HVRootView methodsFor: 'defaults' stamp: 'gk 3/4/2004 14:20'!
serviceName
	"By default we use class name of the HVRootView subclass,
	otherwise the class name of viewClass if we have one."

	^(viewClass notNil and: [self class = HVRootView])
		ifTrue: [viewClass name]
		ifFalse: [self class name]! !

!HVRootView methodsFor: 'comanche' stamp: 'gk 10/23/2003 12:22'!
sessionTimedOut: session
	(model respondsTo: #sessionTimedOut:) ifTrue:[ model sessionTimedOut: session ]! !

!HVRootView methodsFor: 'comanche' stamp: 'gk 11/6/2003 17:18'!
sessionsDo: aBlock
	"Iterate over sessions. Only works if we have turned sessions on,
	check implementors of #useSessions."

	^sessionMod sessionsDo: aBlock
! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:13'!
start
	"Start service on default port in deployment mode."

	^self startOn: self class defaultPort mode: #deployment! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:13'!
startDebug
	"Start service on default port in debug mode."

	^self startOn: self class defaultPort mode: #debug! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:13'!
startDebugOn: portNum
	"Start service on port <portNum> in debug mode."

	^self startOn: portNum mode: #debug! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:13'!
startOn: portNum
	"Start service on port <portNum> in deployment mode."

	^self startOn: portNum mode: #deployment! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 3/3/2004 13:04'!
startOn: portNum mode: mode
	"Creates a new standalone http service with this root view plugged in."

	|  name useSessions ma |
	name _ self serviceName.
	useSessions _ self useSessions.
	ma := ModuleAssembly core.
	coreMod _ ma currentModule.
"	ma logTo: (KomLogger on: Transcript)."
	useSessions ifTrue: [
		ma trackSessions.
		sessionMod _ ma currentModule.
		ma sessionTimeout: 30].
	alias = ''
		ifTrue: [ma addPlug: [:request | self process: request]]
		ifFalse: [ma alias: alias
					to: [ma addPlug: [:request | self process: request]]].
	^(HttpService startOn: portNum named: name)
		plug: ma rootModule; mode: mode! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 3/3/2004 12:13'!
stop
	"Only unregisters the Comanche service,
	override to do proper things when service is stopped."

	self class stop! !

!HVRootView methodsFor: 'views' stamp: 'gk 11/6/2003 14:27'!
topView
	"I have no parent and is thus the top view."

	^self! !

!HVRootView methodsFor: 'private' stamp: 'gk 12/9/2003 16:41'!
urlStream
	"I am the root view and can not hold a urlStream
	because I need to be Process safe."

	^nil! !

!HVRootView methodsFor: 'defaults' stamp: 'gk 3/3/2004 13:03'!
useSessions
	"By default we check with viewClass if we have one,
	otherwise false."

	^viewClass ifNil: [false] ifNotNil: [viewClass useSessions]! !

HVHttpView subclass: #HVTransientView
	instanceVariableNames: 'parent title req urlStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVTransientView commentStamp: 'jlh 12/19/2003 10:30' prior: 0!
A HVHttpView is a web user interface.

A view has a domain object as a model, and thus the HttpView hierarchy often typically mirrors the domain class hierarchy. It also has a reference to it's parent view which ultimately is a HVRootView.

A view is instantiated for every request which means that it does not have to care about multiple Processes (each view instance is only used by one Process - the one started to serve the request) - but since the model can be shared with other views either the model needs to care or the views needs to serialize their access to the model.

The HVRootView is not instantiated for every request - it represents the web application itself that is plugged into Komanche - so it must be written Process safe.

A view holds a reference to the request - 'req' - which it is given upon instantiation. Most of the interaction with the request is done easier through the use of an HVHtmlBuilder which has a lot of support for handling HTML Forms.

Based on the url, the framework will call the method with the same name. For a method to be called from a url the method must be in the 'urls' category. If no method name is given in the url the default method #default is called. The methods should return something responds to #asHttpResponseTo:. The root view sends this message to the object returned and returns the result to Komanche which expects an HttpResponse.

String implements #asHttpResponseTo: so the simplest would be to just return a String with HTML in it. A better approach would be to use an HVHtmlBuilder. Look at HVTodoListView for an example.

Finally HVHttpView includes some simple facilities for keeping track of the user and the current user account.!

HVTransientView subclass: #HVFileDirectoryView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-examples'!

!HVFileDirectoryView commentStamp: 'gk 12/10/2003 14:22' prior: 0!
This web app just gives a file upload/delete user interface on a directory in a filesystem.
Methods commented in detail.

"Fire this app up on port 8080"
HVFileDirectoryView start

"Stop it"
HVFileDirectoryView stop
!

!HVFileDirectoryView class methodsFor: 'as yet unclassified' stamp: 'gk 10/24/2003 15:48'!
createModel
	"This is called when the application is started."

	| dir dirName |
	dirName _ 'testdir'.
	dir _ FileDirectory default.
	(dir directoryExists: dirName)
		ifFalse: [dir createDirectory: dirName].
	^dir directoryNamed: dirName! !

!HVFileDirectoryView methodsFor: 'urls' stamp: 'gk 5/18/2004 14:19'!
default
	"Show the web page for uploading and deleting files."

	| b checkBoxes fn size deleteButton |
	"Create a HTML builder object."
	b _ self builder. 
	
	"Start the page, add a heading level 1."
	b start; h1: 'Files'.
	
	"Start a multipart form with a POST url to the local view instance + '/upload'.
	This will make the POST go the method #upload in this class."
	b postFormMultiPartLocal: 'upload'. 

	"Add an input file field and a submit button with the text 'Upload'.
	In this case we don't care to hold onto the button, the POST goes to the
	#upload method anyways."
	b inputFile; submit: 'Upload'.

	"Add a break making it look better, ending the form and starting a new
	form with no url specified - this makes the POST go to this method by default."
	b br; endForm; postForm.

	"Create a table with 3 columns and specify the column labels."
	b columnsHeads: #('Choose' 'Filename' 'Size') do: [

		"Create a dictionary to hold the checkbox widgets for each file
		using the filename as the key."
		checkBoxes _ Dictionary new.

		model entries do: [:e |
			"For all entries in the directory we pick out filename and size."
			fn _ e first.
			size _ e last.

			"Add a checkbox to the page and take the resulting widget
			and stuff it into the dictionary using the filename as key."
			checkBoxes at: fn put: b inputCheckbox.
	
			"#colTab moves to the next column in the table, there we add
			a link for each file that will point to the #file method in this class
			with the filename added at the end of the url. #colTab also
			automatically moves to the next row in the table."
			b colTab; linkLocal: 'file/', fn text: fn; colTab;
				html: size printString; colTab]].

	"Add a delete button with label."
	deleteButton _ b submit: 'Delete selected files'.

	"End the form, add a horisontal ruler, a link to the source of this method
	and end the web page."
	b endForm; hr; srcLink; end.

	"Ok, if this was a POST of the second form the deleteButton will know it
	and the code will be run. We loop through all entries in the dictionary
	and depending on the #value of each checkbox we delete the file."
	deleteButton ifPressed: [
		checkBoxes keysAndValuesDo: [:name :box |
			box value ifTrue:[model deleteFileNamed: name]].

		"We have changed the model (deleted files) so instead of returning
		the page we just built above, because it contains rows for files
		that are now deleted - we issue a redirect causing a GET reload
		of this page."
		^b redirectToDefault].

	"Return the builder which will cause it to be converted to a HTTP response and thus
	have it render the page back to the user. The last thing HV does is to send #asHttpResponseTo:
	to the object returned from the page methods, see HVRootView>>process: which is the method
	called by Comanche."
	^b! !

!HVFileDirectoryView methodsFor: 'urls' stamp: 'gk 12/10/2003 01:06'!
file
	"Download a file."

	| fileName stream |
	"First we pick out the filename and turn the characters escaped by the browser back."
	fileName _ (self urlStream next) unescapePercents.

	"If the filename is empty we use the inherited method #serverError to return a simple error page.
	Oterwise we open the file and if it exists we finally return the stream which will be converted
	into a HTTP response just before being returned to Comanche."
	fileName isEmpty
		ifTrue: [^self serverError: 'No filename specified in URL.']
		ifFalse:[[stream _ model oldFileNamed: fileName]
					on: FileDoesNotExistException
					do: [^self serverError: 'No file found with name: ', fileName]].
	^stream
! !

!HVFileDirectoryView methodsFor: 'initialize-release' stamp: 'gk 12/9/2003 16:08'!
initialize
	"We set the title of the view - it will show up as the page title."

	title _ model pathName! !

!HVFileDirectoryView methodsFor: 'urls' stamp: 'gk 10/31/2003 11:03'!
upload
	"Upload a file."

	"Here we utilize an inherited convenience method to handle uploaded
	files. The block sent to #handleUpload: will be executed for each file
	uploaded. The block needs to take one argument - the filename, and
	should return a stream or nil. If a stream is returned the file contents
	will be written to it and then the stream will be closed. Returning nil
	ignores the file."
	self handleUpload: [:filename |
		"We simple first delete it if it exists and then return a FileStream
		so that the file gets written."
		(model fileExists: filename) ifTrue:[model deleteFileNamed: filename].
		model newFileNamed: filename].

	"We are done, redirect the user to the #default page."
	^self redirectToDefault! !

HVTransientView subclass: #HVHelloWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-examples'!

!HVHelloWorld commentStamp: 'jlh 12/22/2003 22:35' prior: 0!
This is the minimal web app in HttpView consisting of a single class
inheriting from HVTransientView with a single method called #default.

Well, I added a second variation in method #hello too. :)

You can start the app by simply sending messages to the class:

	HVHelloWorld start
	or
	HVHelloWorld startDebug

...and stop it:

	HVHelloWorld stop

When it is running, surf in at http://localhost:8080 or http://localhost:8080/hello to see it in action!!

Notes:
- The port 8080 is the defaultPort, if you want another port just override that class side method or use startOn:.
- As you can see the path in the url maps automatically to the method name. Just add another method!!
- #startDebug is better than #start when doing development, any bugs will open up the debugger.
- You can stop all apps using #stopAll. !

!HVHelloWorld methodsFor: 'urls' stamp: 'gk 12/10/2003 11:21'!
default
	"The shortest Hello World.
	This is the default method that is run in an HVHttpView
	when no other method has been named in the url.
	It can also be reached by it's name 'default'.
	String implements #asHttpResponseTo: so
	it will be converted to a proper HttpResponse just before being
	handed back to Comanche."

	^'Hello world!!'! !

!HVHelloWorld methodsFor: 'urls' stamp: 'gk 12/10/2003 11:22'!
hello
	"A slightly longer version using HVHtmlBuilder.
	This is how you normally build HTML pages:
		- Get the builder
		- Feed it with messages to create HTML
		- Return it to Comanche, it will then render the page."

	| builder |
	builder _ self builder.
	builder start; h1: 'Hello world!!'.
	builder p: 'It is a brand new day.'.
	builder hr; srcLink; end.
	^builder! !

HVTransientView subclass: #HVSimpleForms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-examples'!

!HVSimpleForms commentStamp: 'gk 12/10/2003 14:22' prior: 0!
This class shows off most of the Forms abilities of HVHtmlBuilder.

"Fire this app up on port 8080"
HVSimpleForms start

"Stop it"
HVSimpleForms stop
!

!HVSimpleForms methodsFor: 'urls' stamp: 'gk 2/19/2004 15:54'!
autosubmit

	| builder field button |
	builder _ self builder.
	builder start; h1: 'Howdy!!'.
	builder p: 'What is your name?'.
	builder postForm.
	field _ builder selectObjectsFirstSelected: #(Hej Hejsan) .
	field autoSubmit: true.
	button _ builder submit.
	builder endForm.
	builder p: 'You selected ', field value asString, '!!'.
	builder hr; srcLink; end.
	^builder! !

!HVSimpleForms methodsFor: 'urls' stamp: 'gk 12/10/2003 11:29'!
megaform1
	"Exercising some forms stuff."

	| b button checkbox checkbox2 code result codeResult |
	b _ self builder.
	b start; h1: 'Megaform'; postForm.

	"Add a checkbox, this box will either be unchecked for a normal GET
	or be checked if the user checks it and presses submit (a POST)."
	checkbox _ b html: 'Is Squeak great?'; inputCheckbox.

	"Add a checkbox, this box will be checked per default.
	If the form shows a proped model for editing typically we pick the value
	from the model object."
	checkbox2 _ b br; html: 'Does Java suck?'; inputCheckboxValue: true.

	"Add a textarea."
	code _ b br; html: 'Enter some code:';br; textArea.

	"Add a paragraph."
	b p: 'Result of code:'.
	"Add a variable - it is simply a placeholder for some HTML."
	result _ b var.
	
	"Add two breaks and a submit button, end the form."
	button _ b br; br; submit: 'Hit me'.
	b endForm.

	"The values of the widgets can be both used and set even if this is not a POST.
	Check if checkbox2 is checked, it should be even on the first GET."
	checkbox2 value ifTrue: [checkbox2 suffix: 'Of course it does...'].

	"If there is no code, stuff some in there."
	code value isEmpty ifTrue: [code value: '3+4'].

	"Was the button pressed?"
	button ifPressed: [
		"If checkbox is checked we add some HTML as a prefix just before the checkbox.
		Note that the actual rendering of the page happens after this method has returned
		so we can manipulate the elements of the page at this point.
		The #error: method simply adds a suffix in red."
		checkbox value
			ifTrue: [checkbox prefix: ' You bet!! ']
			ifFalse: [checkbox error: '<- Come on, check it!!'].

		checkbox2 value
			ifTrue: [checkbox2 suffix: 'Right on!!']
			ifFalse: [checkbox2 error: '<- Come on, check it!!'].
	].
	b hr; srcLink; end.

	"Compile and execute the code. Note that I cobbled this together - I tried adding a bit
	of error handling etc. Not sure how to do this properly."
	codeResult _ [Compiler evaluate: code value logged: false] on: Exception do: [:ex |
						ex class = InMidstOfFileinNotification
							ifTrue: [ex resume: true]
							ifFalse: [ex return: ex]].

	"As a proof that the page is not yet rendered - we can finally stuff in the result of the code
	into the variable we embedded into the page."
	result value: codeResult printString.
	^b! !

!HVSimpleForms methodsFor: 'urls' stamp: 'gk 12/17/2003 13:42'!
megaform2
	"Exercising some forms stuff."

	| b button age years hidden lastAge pass pass2 radioGroup radio1 radio2 radio3 message |
	b _ self builder.
	b start; h1: 'Megaform 2'; postForm.

	"Add a group of radio buttons working as checkboxes,
	The chain of radios need to be ended using endRadio.
	If value isn't given the first one is selected by default. Only one is
	allowed to be selected at any time. Apple will be true and Orange will
	be ignored and set to false. If all has used #inputRadio (without supplying a value)
	then Banana would have been true."
	radio1 _ b html: 'Banana: '; inputRadio.
	radio2 _ b html: radio1 value asString; br; html: 'Apple: '; inputRadioValue: true.
	radio3 _ b html: radio2 value asString; br; html: 'Orange: '; inputRadioValue: true.
	b html: radio3 value asString; endRadio.

	"Add them as one widget, works like selectObjects:."
	radioGroup _ b br; br; html: 'Select fruit:'; br; radioGroup: {'Banana'. 'Apple'. 'Orange'}.
	radioGroup vertical: true.
	b br; columns: 2.		

	"Add a input field for a number. A number field is a simple subclass of text field."
	age _ b html: 'How old are you?'; colTab; inputNumber.

	"Add a input field for a number with a default value different than 0."
	years _ b colTab; html: 'How old is Squeak?'; colTab; inputNumberValue: 9.
	b endColumns; br.

	"Add a hidden field, see below."
	hidden _ b inputHidden.

	"Add a variable that we will fill a few lines down."
	message _ b var.

	"Add a password."
	pass _ b br; br; html: 'Password: '; inputPassword.
	pass2 _ b br; html: 'Verify: '; inputPassword.

	(pass value isEmpty and: [pass2 value isEmpty]) ifFalse: [
		pass value = pass2 value
			ifTrue: [message value: '<b>Verified correctly!!</b>']
			ifFalse: [message value: '<b>Verified incorrectly!!</b>']].
	
	"Add two breaks and a submit button, end the form."
	button _ b br; br; submit: 'Hit me'.
	b endForm.

	"Was the button pressed?"
	button ifPressed: [
		b p: 'You selected a ', radioGroup value, '!!'.
		"Pick out the hidden field value, hidden fields hold Strings so we convert it to a number."
		lastAge _ hidden value asNumber.

		"We stuff the entered age into the hidden field. This means that we will get
		it back on next post - thus we 'remember' the age by storing it in the page."
		hidden value: age value.
	].

	b p: 'You are ', age value printString, ' years old. Last time you entered ',
			lastAge printString, ' years.'.
	b p: 'Squeak is ', years value printString, ' years old.'.

	b hr; srcLink; end.
	^b! !

!HVSimpleForms methodsFor: 'urls' stamp: 'gk 12/10/2003 13:10'!
simplefield
	"This method is called when accessing http://localhost/hello.
	It is first called with a GET thus building the form with an empty
	text field and showing it. The #postForm defaults to an POST url
	pointing to this method again. So when the user press submit
	we end up here again and the form is built the second time.
	This time around the builder object sees that there is a value
	for the textfield and puts that into the HVHtmlInputText instance -
	this happens when the widget is created using the #inputText method,
	so that we can get it by sending #value to it later in the method."

	| builder field button |
	builder _ self builder.
	builder start; h1: 'Howdy!!'.
	builder p: 'What is your name?'.
	builder postForm.
	field _ builder inputText.
	button _ builder submit.
	builder endForm.
	builder p: 'Your name is ', (button ifPressed: [field value] ifNot:['unknown!!']), '!!'.
	builder hr; srcLink; end.
	^builder! !

HVTransientView subclass: #HVTodoListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-examples'!

!HVTodoListView commentStamp: 'gk 12/10/2003 14:21' prior: 0!
This is a minimal todo list web application.

The class side method #createModel is called once when the application is started. At that point a HVRootView is instantiated that holds the model and the root view is plugged into Komanche. This class is then instantiated for each request and has the root view as a parent.

This class implements a trivial initialize method in order to set the prefix and title of the webpage. It then implements two urls:

- The default page which shows the todolist and has a form for adding items and links for removing items.
- The removeitem page which is the method called when a remove link is clicked. It redirects back to the default page.

"Fire this app up on port 8080"
HVTodoListView start

"Stop it"
HVTodoListView stop
!

!HVTodoListView class methodsFor: 'startup' stamp: 'gk 12/10/2003 11:22'!
createModel
	"This is called automatically when the web application is started."

	^HVTodoList new! !

!HVTodoListView methodsFor: 'urls' stamp: 'gk 12/10/2003 11:25'!
default
	"This is the default method that is run in an HVHttpView
	when no other method has been named in the url.
	It can also be reached by it's name 'default'."

	| b item count button |
	b _ self builder.
	b start; h1: 'Todo list'.
	count _ 1.
	item _ b postForm; html: 'Add item: '; inputTextSize: 40.
	button _ b submit.
	button ifPressed: [model addItem: item value].
	b ol: model items do: [:i |
		b linkLocal: 'removeitem?id=', count fullPrintString text: 'R'.
		b html: ' ', i.
		count _ count + 1].
	b endForm; hr; srcLink; end.
	^b! !

!HVTodoListView methodsFor: 'initialize-release' stamp: 'gk 12/9/2003 16:08'!
initialize
	"We set the title of the view - it will show up as the page title."

	title _ 'Todo'! !

!HVTodoListView methodsFor: 'urls' stamp: 'gk 12/10/2003 11:24'!
removeitem
	"Remove an item in the todolist. Here we pick out
	the index from the url with some low level methods in the HttpRequest
	object held in the instance variable req.
	When we are finished we do a redirect to the default page,
	which means that the web browser will reload the #default method in this view."

	| id removeItem |
	id _ (req getFields at: 'id') asNumber.
	removeItem _ model items at: id.
	model removeItem: removeItem.
	^self redirectToDefault! !

!HVTransientView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 10:32'!
on: aModel parent: aParent
	"Create a new view on a model and with aParent as parent view.
	This is normally done on the fly for each request."

	^(super on: aModel) initializeWith: aParent; yourself! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 11/6/2003 17:24'!
accountsLoggedIn
	"Return all accounts logged in now."

	| accounts account |
	accounts _ OrderedCollection new.
	self rootView sessionsDo: [:session |
		account _ session attributes at: #account ifAbsent: [nil].
		account ifNotNil: [accounts add: account]].
	^accounts! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/19/2003 13:27'!
allowedSelector: aSelector
	"Answer true if <aSelector> is ok to call from a URL.
	Default implementation is to delegate to the rootView
	which represents this web application."

	^self rootView allowedSelector: aSelector forView: self ! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/19/2003 13:55'!
allowedSrcSelector: aSelector
	"Answer true if it is ok to view the source for
	<aSelector> from a URL.
	Default implementation is to delegate to the rootView
	which represents this web application."

	^self rootView allowedSrcSelector: aSelector forView: self ! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/10/2003 10:27'!
baseUrl
	"This is the current path of the urlStream."

	^urlStream path! !

!HVTransientView methodsFor: 'html creation' stamp: 'gh 2/8/2002 16:39'!
builder
	"Create a standard builder with our own request."

	^HVHtmlBuilder request: req view: self! !

!HVTransientView methodsFor: 'hacks' stamp: 'gh 12/19/2002 10:38'!
collapsetoc
	"Collapse given entry by updating the session info on which entries to show."

	| entryName toc tocString tocSym |
	tocSym _ self tocSymbol.
	entryName _ req getFields at: #entry.
	toc _ req session attributes at: tocSym ifAbsent:[^self redirectToDefault].
	toc _ ((toc findTokens: $,) collect: [:s | s asSymbol]) asSet.
	toc remove: entryName asSymbol ifAbsent: [nil].
	tocString _ String streamContents: [:s |
		toc do: [:sym | s nextPutAll: sym, ',']].
	req session attributes at: tocSym put: tocString.
	^self redirectToDefault! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 10:46'!
createSelectWidget: values name: name 
	"Create a select widget for forms."

	self deprecatedExplanation: 'Deprecated, use select* methods in HVHtmlBuilder instead.'.
	^self createSelectWidget: values selected: 1 name: name! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 10:46'!
createSelectWidget: values selected: selected name: name 
	"Create a select widget for forms."

	self deprecatedExplanation: 'Deprecated, use select* methods in HVHtmlBuilder instead.'.
	^self createSelectWidget: values selected: selected name: name withIds: true
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 10:47'!
createSelectWidget: objects selected: selected name: name withIds: withIds
	"Create a select widget for forms."

	| obj id |
	self deprecatedExplanation: 'Deprecated, use select* methods in HVHtmlBuilder instead.'.
	^String streamContents: [:stream |
		stream nextPutAll: '<select name="', name, '" size="1">'.
		1 to: objects size do: [:n |
			obj _ objects at: n.
			withIds ifTrue:[ id _ obj id] ifFalse:[ id _ n].
			(id = selected)
				ifTrue: [ stream nextPutAll: '<option selected']
				ifFalse: [ stream nextPutAll: '<option' ].
			withIds
				ifTrue: [stream nextPutAll: ' value="', id fullPrintString, '">']
				ifFalse: [stream nextPut: $> ].
			stream nextPutAll: obj name; nextPutAll: '</option>'.
		].
		stream nextPutAll: '</select>']
! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 11/6/2003 14:55'!
currentAccount
	"Get the account for the request."

	| session |
	session _ KomSession current.
	^session ifNotNil: [session attributes at: #account ifAbsent: [nil]]! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 3/3/2004 11:47'!
currentAccount: anAccount
	"Set the account for this session."

	KomSession current attributes at: #account put: anAccount! !

!HVTransientView methodsFor: 'hacks' stamp: 'gh 10/18/2002 15:37'!
currentToc
	"Get the TOC for the request."

	^req session attributes at: self tocSymbol ifAbsent: [nil]! !

!HVTransientView methodsFor: 'urls' stamp: 'gh 2/11/2002 18:33'!
default
	"This is the default method called on a HttpView if no other
	method is named in the url. It is the base page for the view.
	It should always be implemented. This is a simple test implementation."

	| b |
	b _ self builder.
	b start; h1: 'View for model:'; p: model printString; end.
	^b! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/10/2003 00:55'!
defaultUrl
	"Return a url String representing this view's
	current position within the url of the request
	with #default appended."

	^urlStream pathWith: #default! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/10/2003 11:05'!
dispatch
	"Dispatch to correct method in this view."

	^self dispatchOn: self nextMethod! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/19/2003 13:52'!
dispatchOn: method 
	"Dispatch to correct method:
	- If method is empty we call #default
	- If the selector is allowed to be executed then we just call it
	- If method is prefixed with 'src' and viewing the source is allowed,
		then we return a HTML page with the source for that method."

	| m |
	method isEmptyOrNil ifTrue:[ ^self default ].
	m _ method asSymbol.
	(self allowedSelector: m)
		ifTrue:[^self perform: m].

	"Is it a request for the source?"
	(m beginsWith: 'src')
		ifTrue: [
			m _ (m asString last: (m size - 3)) asSymbol.
			(self allowedSrcSelector: m)
				ifTrue: [^self showSourceFor: m]
				ifFalse: [^self serverError: 'Not allowed to view source']]
		ifFalse: [^self serverError: 'Specified URL not allowed']! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 10:59'!
endhtml
	"Standard end."

	self deprecatedExplanation: 'Deprecated, use the HVHtmlBuilder to build HTML instead.'.

^'</body></html>'! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 10:59'!
endhtml: request
	"Standard end. Attach a link to the source of the page."

	| url slash |
	self deprecatedExplanation: 'Deprecated, use the HVHtmlBuilder to build HTML instead.'.
	slash _ request url findLast: [:c | c = $/ ].
	url _ (request url copyFrom: 1 to: slash), 'src', (request url copyFrom: slash + 1 to: request url size).
^'<hr><br><font size=-1>', (self link: url text: 'See source for this page'), '</font></body></html>'! !

!HVTransientView methodsFor: 'hacks' stamp: 'gh 10/18/2002 15:36'!
expandtoc
	""

	| entryName toc tocString tocSym |
	tocSym _ self tocSymbol.
	entryName _ req getFields at: #entry.
	toc _ req session attributes at: tocSym ifAbsent: [nil].
	toc ifNotNil: [
		toc _ ((toc findTokens: $,) collect: [:s | s asSymbol]) asSet.
		toc add: entryName asSymbol.
		tocString _ String streamContents: [:s |
			toc do: [:sym | s nextPutAll: sym, ',']]]
		ifNil: [toc _ ''].
	req session attributes at: tocSym put: tocString.
	^self redirectToDefault! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 12/10/2003 11:15'!
fixForHtml: string
	"Replace a lot of characters with HTML friendly stuff."

	| temp |
	(string isEmpty or: [string isNil]) ifTrue:[^string].
	temp _ string copyReplaceAll: '&' with: '&amp;'.
	HtmlEntities keysAndValuesDo:
		[:entity :char |
		char = $& ifFalse:
			[temp _ temp copyReplaceAll: char asString with: '&' , entity , ';']].
	^'<pre>', (temp copyReplaceAll: '_' with: ':='), '</pre>'! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 10/29/2003 16:12'!
handleUpload: aBlock
	"If the request is a multipart POST we will
	extract the filename for each chunk and
	call aBlock with that filename. If a stream
	is returned from the block we will write the
	chunk to that stream and close it."

	| fileName stream |
	req isPostMultipart ifTrue: [
		req multipartFormFieldsDo: [:chunk |
			chunk fileName isEmptyOrNil ifFalse: [
				fileName _ (chunk fileName findTokens: ':/\') last.
				stream _ aBlock value: fileName.
				stream ifNotNil: [
					[chunk saveToStream: stream]
						ensure: [stream close]]]]]! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'gk 10/24/2003 10:29'!
initialize
	super initialize.
	title _ 'No title set'! !

!HVTransientView methodsFor: 'html creation' stamp: 'gk 3/26/2004 15:19'!
initializeWith: aParent
	"If we have no request set yet, we pick it from our parent.
	If aParent is nil then request is set later in #process: instead."

	aParent ifNotNil: [
		parent _ aParent.
		req ifNil: [req _ parent request. urlStream _ parent urlStream]].
	self initialize; postInitialize! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 3/3/2004 12:52'!
isLoggedIn
	"Check if the user is logged in."

	| session |
	session _ KomSession current.
	^session ifNotNil: [session attributes includesKey: #account] ifNil: [false]! !

!HVTransientView methodsFor: 'testing' stamp: 'gh 9/20/2002 09:36'!
isTopView
	"Am I a topview?"

	^false! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 10:48'!
link: url text: text
	"Return a HTML link."

	self deprecatedExplanation: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.
	^String streamContents: [:stream |
		stream
			nextPutAll: '<a href="';
			nextPutAll: url;
			nextPutAll: '">'; nextPutAll: text; nextPutAll: '</a>' ]
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 10:48'!
linkBack: text
	"Return a local back link to the default page."

	self deprecatedExplanation: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.
	^self link: self defaultUrl text: text
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 10:48'!
linkBackParent: text
	"Return a back link to the default page of the parent."

	self deprecatedExplanation: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.
	^self link: parent defaultUrl text: text
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 10:49'!
linkBase: server local: relativeUrl text: text
	"Return a local link to the view."

	self deprecatedExplanation: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.
	^self link: server, (self urlFor: relativeUrl) text: text
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 3/3/2004 16:09'!
linkLocal: relativeUrl text: text
	"Return a local link to the view."
0 halt.
	self deprecatedExplanation: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.
	^self link: (self urlFor: relativeUrl) text: text
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 10:50'!
linkback: text
	"Return a local backlink."

	self deprecatedExplanation: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 10:50'!
linkbackparent: text
	"Return a parent backlink."

	self deprecatedExplanation: 'Deprecated, use getLink* and link* methods in HVHtmlBuilder instead.'.! !

!HVTransientView methodsFor: 'urls' stamp: 'gk 3/4/2004 14:33'!
logout
	"By default we logout the account and redirect to the default page."

	self logoutAccount; redirectToDefault! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 3/4/2004 14:23'!
logoutAccount
	"Tell the account that it is being logged out.
	Clear out the account attribute in the session.
	Return true if all succeded."

	self currentAccount ifNil: [^true].
	(self currentAccount respondsTo: #logout) ifTrue: [
		self currentAccount logout].
	KomSession current attributes removeKey: #account ifAbsent: [^false].
	^true! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gh 5/24/2002 15:19'!
message: message
	"Return a single page with a message and a back link to base page of this view."

	^self builder start; h1: message; linkBack: 'Back'; end; yourself
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gk 12/10/2003 10:57'!
message: message backlink: link
	"Return a single page with a message and a link back relative to the view."

	^self message: message linkLocal: link
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gk 12/10/2003 10:57'!
message: message link: link
	"Return a single page with a message and an absolute back link."

	| b |
	b _ self builder.
	^b start; h1: message; link: link text: 'Back'; end; yourself
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gk 12/10/2003 00:01'!
message: message linkLocal: link
	"Return a single page with a message and a back link relative to this view."

	^self message: message linkLocal: link text: 'Back'
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gk 12/10/2003 10:58'!
message: message linkLocal: link text: text
	"Return a single page with a message and a back link relative to this view."

	| b |
	b _ self builder.
	^b start; h1: message; linkLocal: link text: text; end; yourself
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 11:08'!
message: message linklocal: link
	"Return a single page with a message and a back link relative to this view."

	self deprecatedExplanation: 'Deprecated, use #message:linkLocal: instead (capital L).'.
	^self message: message linkLocal: link
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 11:09'!
message: message linklocal: link text: aText
	"Return a single page with a message and a back link relative to this view."

	self deprecatedExplanation: 'Deprecated, use #message:linkLocal:text: instead (capital L).'.
	^self message: message linkLocal: link text: aText
! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gh 5/24/2002 15:22'!
message: message text: text
	"Return a single page with a message and a back link to base page of this view."

	^self builder start; h1: message; linkBack: text; end; yourself
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 11:03'!
methodAfter: aPrefix

	self deprecatedExplanation: 'Deprecated, use #nextMethod or similar methods instead.'.

	^self methodInUrl: req rawUrl after: aPrefix! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 11:04'!
methodInUrl: url after: aPrefix
	"Extracts the method from the url.
	The methodname is after the prefix upto the first $? $/ or end of url like this:
	'/prefix/method/knirk?habbadubba' => 'method'
	'/prefix/method?habbadubba' => 'method'
	'/prefix/method' => 'method'
	'/prefix/' => ''
	'/prefix' => ''"

	| method endq ends |
	self deprecatedExplanation: 'Deprecated, use #nextMethod or similar methods instead.'.

	(url = aPrefix) ifTrue:[ ^'' ].
	method _ url copyFrom: aPrefix size + 1 to: url size.
	(method = '/') ifTrue:[ ^'' ].
	method _ method allButFirst.
	endq _ method indexOf: $?.
	ends _ method indexOf: $/.
	(endq = 0) ifTrue:[ endq _ method size + 1].
	(ends = 0) ifTrue:[ ends _ method size + 1].
	^method copyFrom: 1 to: (ends min: endq) - 1! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/10/2003 11:05'!
nextMethod
	"Pick out the next method (path part = directory) from the urlStream."

	^urlStream next! !

!HVTransientView methodsFor: 'accessing' stamp: 'gk 12/10/2003 10:21'!
parent
	"Return my parent view."

	^parent! !

!HVTransientView methodsFor: 'parent views' stamp: 'gk 12/10/2003 10:23'!
parentsDo: aBlock
	"Iterate over the parent views my parent first."

	aBlock value: parent.
	parent parentsDo: aBlock! !

!HVTransientView methodsFor: 'parent views' stamp: 'gk 12/10/2003 10:25'!
parentsDoReverse: aBlock
	"Iterate over the parent views root view first."

	parent parentsDoReverse: aBlock.
	aBlock value: parent! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 3/2/2004 17:28'!
peekNextMethod
	"Pick out the next method (path part = directory) from the urlStream."

	^urlStream peek! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'gh 9/20/2002 14:31'!
postInitialize
! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 11:07'!
prefix

	self deprecatedExplanation: 'Deprecated, use #nextMethod or other methods in category dispatch.'! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 11/10/2003 23:56'!
reload
	"Make a redirection to same url."

	^HttpResponse redirectTo: req rawUrl! !

!HVTransientView methodsFor: 'accessing' stamp: 'gh 2/8/2002 16:28'!
request
	^req! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'gk 5/12/2004 13:40'!
request: aRequest
	"This method is only used from #process: when creating the first view."

	req _ aRequest.
	req ifNotNil: [
		urlStream _ HVUrlStream on: (Url absoluteFromText: req rawUrl)]! !

!HVTransientView methodsFor: 'parent views' stamp: 'gk 12/10/2003 10:22'!
rootView
	"Return the view at the root, the root view will return self."

	^parent rootView! !

!HVTransientView methodsFor: 'simple messages' stamp: 'gk 12/10/2003 10:52'!
serverError: aString
	"Return an error to the user."

	^self builder start; h1: 'Error'; p: 'Returned by server: <b>', aString, '</b>'; end; yourself! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 5/6/2004 15:29'!
sessionAt: key
	"Get the value in the current session for the request."

	^self sessionAt: key ifAbsent: [nil]! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 5/6/2004 15:28'!
sessionAt: key ifAbsent: block
	"Get the value in the current session for the request."

	^KomSession current attributes at: key ifAbsent: block! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 5/6/2004 15:38'!
sessionAt: key ifAbsentPut: block
	"Get the value in the current session for the request.
	If absent, set it to the value of the block."

	^KomSession current attributes at: key ifAbsent: [self sessionAt: key put: block value]! !

!HVTransientView methodsFor: 'accounts' stamp: 'gk 5/6/2004 15:29'!
sessionAt: key put: value
	"Set the value in the current session for the request."

	^KomSession current attributes at: key put: value! !

!HVTransientView methodsFor: 'hacks' stamp: 'gh 10/18/2002 15:37'!
setToc: aToc
	"Set the TOC for the request."

	req session attributes at: self tocSymbol put: aToc! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 12/10/2003 11:02'!
showSourceFor: selector
	"Show the source for given selector."

	| b |
	b _ self builder.
	^b start; h2: ('Source for ', self class name, '>>', selector);
		pre: (self fixForHtml: (self class sourceMethodAt: selector) asString);
		end; yourself! !

!HVTransientView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 11:59'!
start
	"Start the web app."

	self class start! !

!HVTransientView methodsFor: 'deprecated' stamp: 'gk 12/10/2003 11:00'!
starthtml
	"Standard start."

	self deprecatedExplanation: 'Deprecated, use the HVHtmlBuilder to build HTML instead.'.

^'<html><head><title>', self title, '</title></head><body>'! !

!HVTransientView methodsFor: 'start-stop' stamp: 'gk 10/24/2003 09:14'!
stop
	"Stop service with name of class."

	self class stop! !

!HVTransientView methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:58'!
title
	^title! !

!HVTransientView methodsFor: 'parent views' stamp: 'gk 11/6/2003 14:26'!
topView
	"Return the view that thinks it is a top view."

	^self isTopView
		ifTrue: [self]
		ifFalse: [parent topView]! !

!HVTransientView methodsFor: 'html creation' stamp: 'gk 5/18/2004 13:58'!
transitionalXHTMLBuilder
	"Create a XHTML transitional builder with our own request."

	| b |
	b _ HVHtmlBuilder request: req view: self.
	b declaration: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'.
	b document html attributeAt: #xmlns put: 'http://www.w3.org/1999/xhtml'.
	b
		attributeAt: #'http-equiv' put: 'Content-type';
		attributeAt: #content put: 'text/html; charset=UTF-8'; headTag: #meta.
	^b! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/9/2003 16:20'!
urlFor: stringOrSymbol
	"Return a url String representing this view's
	current position within the url of the request
	with <stringOrSymbol> appended."

	^urlStream pathWith: stringOrSymbol! !

!HVTransientView methodsFor: 'accessing' stamp: 'gk 12/9/2003 15:04'!
urlStream
	^urlStream! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 3/2/2004 16:29'!
validateEmail: aString
	"Validate that <aString> conforms to at least this syntax:
		'something @ something . something'
	"

	| s at dot |
	s _ aString withBlanksTrimmed.
	at _ aString indexOf: $@.
	dot _ s indexOf: $. startingAt: at.
	((dot * at) = 0) ifTrue:[^false].
	(at > 1) & (at < dot) & (dot < s size) ifFalse:[^false].
	^true! !

!HVTransientView methodsFor: 'utilities' stamp: 'gh 5/30/2002 13:42'!
validateSafeString: aString

	aString do: [:c | (SafeChars includes: c) ifFalse:[^false]].
	^true! !

!HVTransientView methodsFor: 'utilities' stamp: 'gh 5/30/2002 13:58'!
validateUltraSafeString: aString

	aString do: [:c | (UltraSafeChars includes: c) ifFalse:[^false]].
	^true! !

!HVTransientView methodsFor: 'css' stamp: 'gk 5/18/2004 15:13'!
w3cButtons: aStream
	"Append some CSS for slick W3C validation buttons."

	aStream nextPutAll:
'div.w3cbutton1 {
  position: relative;
  margin: 1em 0;
  font-family: helvetica,arial,sans-serif;
  font-size: 0.9em;
  font-weight: bold;
}
div.w3cbutton1 a {
  display: block;
  border-top: 1px solid #cecece;
  border-bottom: 2px solid #4a4a4a;
}
div.w3cbutton1 a.w3c1 {
  width: 3em;
  border-left: 1px solid #cecece;
  text-align: center;
}
div.w3cbutton1 a.spec1 {
  position: absolute;
  left: 3em;
  top: 0;
  width: 6em;
  border-right: 2px solid #4a4a4a;
  padding-left: 0.5em;
}
div.w3cbutton1 a.w3c1:link,
div.w3cbutton1 a.w3c1:visited,
div.w3cbutton1 a.w3c1:hover {
  background-color: #fff;
  color: #0c479d;
  text-decoration: none;
}
div.w3cbutton1 a.spec1:link,
div.w3cbutton1 a.spec1:visited,
div.w3cbutton1 a.spec1:hover {
  background-color: #fc6;
  color: #000;
  text-decoration: none;
}'! !

Object subclass: #HVTableOfContentsEntry
	instanceVariableNames: 'name label parent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVTableOfContentsEntry classSide methodsFor: 'instance creation' stamp: 'gh 9/12/2002 16:19'!
name: aSymbol label: aString parent: aToc
	^self new name: aSymbol label: aString parent: aToc! !

!HVTableOfContentsEntry methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:27'!
closedImageUrl
	^parent closedImageUrl! !

!HVTableOfContentsEntry methodsFor: 'rendering' stamp: 'gh 9/18/2002 11:25'!
fullName
	| str |
	str _ parent fullName.
	^(str isEmpty or: [str last = $/]) ifTrue: [str, name] ifFalse: [str, '/', name]! !

!HVTableOfContentsEntry methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:27'!
leafImageUrl
	^parent leafImageUrl! !

!HVTableOfContentsEntry methodsFor: 'entries' stamp: 'gh 9/12/2002 16:27'!
name: aName label: aLabel
	"Add a new top level entry in the TOC.
	Return the entry."

	children ifNil: [children _ OrderedCollection new].
	^children add: (HVTableOfContentsEntry name: aName label: aLabel parent: self)! !

!HVTableOfContentsEntry methodsFor: 'initialize-release' stamp: 'gh 9/17/2002 17:47'!
name: aSymbol label: aString parent: aToc
	name _ aSymbol.
	parent _ aToc.
	label _ aString! !

!HVTableOfContentsEntry methodsFor: 'rendering' stamp: 'gh 10/17/2002 15:27'!
openImageUrl
	^parent openImageUrl! !

!HVTableOfContentsEntry methodsFor: 'rendering' stamp: 'gk 12/17/2003 11:13'!
printHtmlOn: stream expanded: expanded level: aLevel builder: aBuilder
	"Render entry."

	| url view |
	view _ aBuilder view.
	aLevel timesRepeat: [stream nextPutAll: '&nbsp;&nbsp;&nbsp;'].
	url _ self fullName.
	children isEmptyOrNil 
		ifTrue:[stream
				nextPutAll: (aBuilder getLink: url text: (aBuilder getImage: self leafImageUrl));
				nextPutAll: '&nbsp;';
				nextPutAll: (aBuilder getLink: url text: label);
				nextPutAll: '<br />']
		ifFalse:[
			(expanded includes: name)
				ifTrue:[
					stream
						nextPutAll: (view linkLocal: 'collapsetoc?entry=', name text: (aBuilder getImage: self openImageUrl));
						nextPutAll: '&nbsp;';
						nextPutAll: (aBuilder getLink: url text: label);
						nextPutAll: '<br />'.
					children do: [:child |
						child printHtmlOn: stream expanded: expanded level: aLevel + 1 builder: aBuilder]]
				ifFalse:[
					stream
						nextPutAll: (view linkLocal: 'expandtoc?entry=', name text: (aBuilder getImage: self closedImageUrl));
						nextPutAll: '&nbsp;';
						nextPutAll: (aBuilder getLink: url text: label);
						nextPutAll: '<br />']].
	! !

Object subclass: #HVTodoList
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-examples'!

!HVTodoList commentStamp: 'gk 10/24/2003 10:58' prior: 0!
This is a very simple domain object for a todolist. I only have an OrderedCollection holding the items and a few simple methods for adding and removing items from the collection.

This class contains no code whatsoever specific to HttpView.!

!HVTodoList class methodsFor: 'instance creation' stamp: 'gh 2/12/2002 10:36'!
new
	^super new initialize! !

!HVTodoList methodsFor: 'items' stamp: 'gh 2/12/2002 10:37'!
addItem: item

	^items add: item! !

!HVTodoList methodsFor: 'initialize-release' stamp: 'gh 2/12/2002 10:36'!
initialize
	items _ OrderedCollection new! !

!HVTodoList methodsFor: 'items' stamp: 'gh 2/12/2002 10:37'!
items

	^items! !

!HVTodoList methodsFor: 'items' stamp: 'gh 2/12/2002 10:37'!
removeItem: item

	^items remove: item! !

Object subclass: #HVUrlStream
	instanceVariableNames: 'url stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVUrlStream commentStamp: 'gk 12/10/2003 10:12' prior: 0!
A HVUrlStream is a PositionableStream on a URL path.
We could just use a ReadStream on the path itself - but this way both the url and the stream on the path is kept together in one unit. We can also add some special behavior.
!

!HVUrlStream class methodsFor: 'instance creation' stamp: 'gk 12/9/2003 14:56'!
on: aUrl
	"Return a stream on the url."

	^self new url: aUrl! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 12/10/2003 10:15'!
back
	"Back up one step in the stream."

	stream position: ((stream position - 1) min: 1)! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 12/9/2003 14:57'!
next

	^stream next! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 12/10/2003 01:00'!
path
	"Return an absolute url of the current path
	separated with /-characters, like this:

	/aba/dabba"

	| path part |
	path _ url path.	
	^String streamContents: [:s |
		1 to: stream position - 1 do: [:i |
			part _ path at: i.
			part isEmpty ifFalse: [
				s nextPut: $/; nextPutAll: part]]]! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 12/10/2003 01:00'!
pathWith: aStringOrSymbol
	"Return a absolute url of the current path
	with <aStringOrSymbol> appended, separated
	with /-characters, like this:

	/aba/dabba/<aStringOrSymbol>"

	| path part |
	path _ url path.	
	^String streamContents: [:s |
		1 to: stream position - 1 do: [:i |
			part _ path at: i.
			part isEmpty ifFalse: [
				s nextPut: $/; nextPutAll: part]].
		s nextPut: $/; nextPutAll: aStringOrSymbol]! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 12/9/2003 17:58'!
pathWithPrefix: aStringOrSymbol
	"Return a relative url of the current path
	with <aStringOrSymbol> prepended to the last
	path parh. Path parts are separated with /-characters,
	like this:

	/aba/dabba/<aStringOrSymbol>yabba"

	| path |
	path _ url path.	
	^String streamContents: [:s |
		1 to: stream position - 1 do: [:i |
			s nextPut: $/; nextPutAll: (path at: i)].
		s nextPut: $/; nextPutAll: aStringOrSymbol, (path last)]! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 12/10/2003 10:13'!
peek

	^stream peek! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 12/9/2003 14:57'!
position

	^stream position! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 12/9/2003 14:56'!
position: pos

	stream position: pos! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 12/9/2003 14:57'!
reset

	^stream reset! !

!HVUrlStream methodsFor: 'initialize-release' stamp: 'gk 12/9/2003 15:00'!
url
	^url! !

!HVUrlStream methodsFor: 'initialize-release' stamp: 'gk 12/9/2003 14:56'!
url: aUrl

	url _ aUrl.
	stream _ ReadStream on: aUrl path! !

WVHtmlBuilder subclass: #HVHtmlBuilder
	instanceVariableNames: 'request view fields variables maxCol currentCol lastRadio lastForm response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HV-base'!

!HVHtmlBuilder commentStamp: '<historical>' prior: 0!
HVHtmlBuilder builds HTML pages and handles HTML Forms. It has a reference to the HVHttpView that created it (for various services) and to the request of that view.

Typical use is to instantiate it (HVHttpView has a method #builder which creates one), feed it "build messages" and then finally calling #render which will stream out the resulting HTML page. This is an example:

builder _ self builder.
builder start; h1: 'A heading'; postForm; inputText: #name; submit; endForm; end.
builder render

During the build some of the "build messages" return objects that can be used for input and output - typically objects representing Forms, Inputfields, Submit buttons etc. The messages #postForm, #inputText: and #submit all returned objects in the code above but the code chose to ignore them.

The contents message causes the builder to assemble the finished HTML document and return it as a String, but normally you just return the builder itself since HVHtmlBuilder also implements #asHttpResponseTo: which means that it can be returned as a result to Comanche from an 'url' method in a HVHttpView class. So you do not need to call #render and actually, in order to compose pages from multiple methods it is better if you do not call #render.

...

elements - An OrderedCollection holding all elements that constitute the page.
elementStack - An OrderedCollection acting as a stack for certain elements like for example forms.

!

!HVHtmlBuilder class methodsFor: 'instance creation' stamp: 'gh 1/31/2002 14:41'!
request: aRequest view: aView
	^self new request: aRequest view: aView; yourself! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/16/2003 17:54'!
addForm: aForm
	"Add the form to the document.
	The form is also given an id for this page."

	| id |
	id _ lastForm ifNil: [1] ifNotNil: [lastForm id + 1].
	aForm id: id.
	lastForm _ aForm.
	^document pushElement: aForm

! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gk 12/17/2003 11:46'!
addHtmlInput: aVar
	"Add the input variable in the correct Form and
	also add it to the page."

	lastForm addInput: aVar.
	^document addElement: aVar

! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gk 12/17/2003 11:47'!
addVar: aVar
	"Add the variable in the correct Form and
	add it to the document."

	lastForm addInput: aVar. "???"
	^document addElement: aVar

! !

!HVHtmlBuilder methodsFor: 'comanche' stamp: 'gk 3/3/2004 14:38'!
asHttpResponseTo: req
	"We implement this so that a builder can be returned as a
	result from a method rather than a HTML String.
	This also enables nestling of builders in order to compose
	pages by calling other 'submethods'."

	response ifNil: [
		response _ (HttpResponse fromString: self render)
			fieldAt: 'Pragma' put: 'no-cache';
			fieldAt: 'Cache-Control' put: 'no-cache'].
	^response
		! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 2/15/2002 14:11'!
asString
	^self render! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 6/12/2002 10:36'!
at: var ifAbsent: block
	"Low level access to fields - parameters to GET or POST."

	^fields at: var ifAbsent: [^block value]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/16/2003 16:08'!
b: anObject
	self tag: 'b' do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 11:40'!
blockquote
	^self openTag: 'blockquote'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 11:38'!
blockquote: anObject
	^self tag: 'blockquote' do: anObject! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 6/12/2002 10:35'!
bodytag
	"This is a way to be able to customize the body.
	Perhaps there are much better ways but this was simple."
	
	^variables at: #bodytag ifAbsent: [nil]

! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 6/12/2002 10:36'!
booleanAt: var ifAbsent: block
	"Customized version for checkboxes."

	^(fields at: var ifAbsent: [^block value]) = 'on'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/16/2003 18:06'!
br
	^self break! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:15'!
cell
	^self openTag: 'td'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:15'!
cell: anObject
	^self tag: 'td' do: anObject! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:15'!
cellCenter
	self halt! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 12/17/2003 11:42'!
colTab
	currentCol = maxCol
		ifTrue:[self close; close; tr; td.
				currentCol _ 1]
		ifFalse:[self close; td.
				currentCol _ currentCol + 1]! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 12/17/2003 12:04'!
colTabTop
	currentCol = maxCol
		ifTrue:[self close; close; attributeAt: 'valign' put: 'top'; tr; td.
				currentCol _ 1]
		ifFalse:[self close; td.
				currentCol _ currentCol + 1]! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 5/12/2004 12:09'!
columns: cols
	self attributeAt: 'border' put: '0';
		 attributeAt: 'cellpadding' put: '2';
		attributeAt: 'cellspacing' put: '0'.
	self table; tr; td.
	maxCol _ cols.
	currentCol _ 1! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 5/18/2004 14:17'!
columnsHeads: heads do: aBlock
	self attributeAt: 'cellpadding' put: '2';
		 attributeAt: 'cellspacing' put: '3'.
	self table; heads: heads; tableBody; tr; td.
	maxCol _ heads size.
	currentCol _ 1.
	aBlock value.
	self close; close; close; close! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 12/17/2003 12:02'!
columnsWide: cols
	self attributeAt: 'border' put: '0';
		attributeAt: 'cellpadding' put: '0';
		attributeAt: 'cellspacing' put: '3';
		attributeAt: 'width' put: '100%'.
	self table; tr; td.
	maxCol _ cols.
	currentCol _ 1! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 12/17/2003 12:03'!
columnsWideTop: cols
	self attributeAt: 'border' put: '0';
		attributeAt: 'cellpadding' put: '0';
		attributeAt: 'cellspacing' put: '3';
		attributeAt: 'width' put: '100%'.
	self table; attributeAt: 'valign' put: 'top'; tr; td.
	maxCol _ cols.
	currentCol _ 1! !

!HVHtmlBuilder methodsFor: 'buttons' stamp: 'gk 5/18/2004 15:29'!
cssButton

	self text: '<div class="w3cbutton1"><a class="w3c1" href="http://www.w3.org/">W3C</a><a class="spec1" href="http://jigsaw.w3.org/css-validator/check/referer">CSS</a></div>'! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gk 12/16/2003 17:54'!
currentForm
	"Find current form by looking in the stack."

	^lastForm

! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 11:40'!
data
	self halt! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/16/2003 17:15'!
divClass: aString
	"Start a div with a class."

	^document pushElement: (HVHtmlDiv class: aString)! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/16/2003 17:15'!
divId: anId
	"Start a div with an id."

	^document pushElement: (HVHtmlDiv id: anId)

	"^elements add: div"! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 11:39'!
end
	"Do nothing."

"	^elements add: '</body></html>'"! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:04'!
endBlockquote
	^self close! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:14'!
endCell
	^self close! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 12/17/2003 10:31'!
endColumns
	"Cell, row, table."
	self close; close; close! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:14'!
endData
	^self close! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/18/2002 13:28'!
endDiv
	^self endTag! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/15/2002 14:52'!
endForm
	^self endTag! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:14'!
endP
	^self close! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 13:39'!
endRadio
	"Close the last radio if we find one."

	lastRadio ifNotNil: [lastRadio close]! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:14'!
endRow
	^self close! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:13'!
endTable
	^self close! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gk 12/16/2003 17:04'!
endTag
	"We assume that the last element on the stack is the correct one."

	^document popElement

	"^elements add: (HVHtmlEndtag for: elementStack removeLast)"! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 9/12/2002 13:23'!
findVar: aName
	"Find a named variable."

	^variables at: aName ifAbsent: [nil]! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:16'!
getForm
	"Start a GET form that will return to the same url as this request."

	^self addForm: (HVHtmlForm getAction: request url)! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 9/12/2002 16:06'!
getImage: url
	"Embed an image."

	^'<img src="', url, '" alt="no description" />'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 10/16/2002 16:03'!
getImage: url description: desc
	"Embed an image."

	^'<img src="', url, '" alt="', desc, '" />'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/10/2003 10:33'!
getLink: url
	"Return a HTML link with the url shown as the text."

	^self getLink: url text: url! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/10/2003 10:33'!
getLink: url text: text
	"Return a HTML link."

	^'<a href="', url, '">', text, '</a>'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/10/2003 00:51'!
getLinkLocal: relativeUrl text: text
	"Return a local HTML link to the view."

	^self getLink: (view urlFor: relativeUrl) text: text! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:25'!
green: anObject
	^self attributeAt: 'color' put: 'red'; tag: 'font' do: anObject! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:15'!
greyRow
	self halt! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 09:11'!
h1: anObject
	^self tag: 'h1' do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 09:55'!
h2: anObject
	^self tag: 'h2' do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 09:55'!
h3: anObject
	^self tag: 'h3' do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 09:55'!
h4: anObject
	^self tag: 'h4' do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 09:55'!
h5: anObject
	^self tag: 'h5' do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 09:55'!
h6: anObject
	^self tag: 'h6' do: anObject! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 5/18/2004 15:35'!
heads: heads
	"Add heads to a table that has already been started."

	self tableHead: [
		self tableRow: [
			heads do: [:head |
				self attributeAt: 'align' put: 'left'.
				self tableHeading: head]]]
! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 10:04'!
hr
	^self tag: 'hr'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:12'!
html: anObject
	"No encoding made, we just use #asString on anObject."

	^self text: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 11:40'!
i: anObject
	^self italic: anObject! !

!HVHtmlBuilder methodsFor: 'html-forms-queries' stamp: 'gk 12/10/2003 10:42'!
ifPost: aBlock
	"If it is a POST we run the block.
	Better to use #ifPressed: on the submit button." 

	^self isPost ifTrue:[aBlock value]! !

!HVHtmlBuilder methodsFor: 'html-forms-queries' stamp: 'gk 12/10/2003 10:42'!
ifSubmit: aBlock
	"If it is a POST or a GET with fields we run the block."

	request isPostRequest ifTrue:[^aBlock value].
	request isGetRequest ifTrue:[request getFields isEmpty ifFalse:[^aBlock value]]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 11/11/2003 10:57'!
image: aURL
	"Add an image."

	^self image: aURL description: nil! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 11:35'!
image: url description: altString
	"Embed an image."

	^self image: url altText: altString

	"^elements add: (HVHtmlImage url: url alt: desc)"! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:18'!
inputCheckbox
	"Add a checkbox, name is autogenerated and default value is false (unchecked)."

	^self inputCheckbox: self nextVarName value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:18'!
inputCheckbox: name
	"Add a checkbox, use if you need to supply your own name.
	Default value is false (unchecked)."

	^self inputCheckbox: name value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:20'!
inputCheckbox: name value: default
	"Add a checkbox named <name> with default value <default>.
	The value should be false or true. If the current request has
	posted this field then the value is picked from there."

	| val |
	val _ default.
	self ifSubmit: [
		val _ (fields includesKey: name)
			ifTrue:[ (fields at: name) = 'on' ]
			ifFalse: [ false ]].
	^self addHtmlInput: (HVHtmlInputCheckbox name: name value: val)! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:20'!
inputCheckboxValue: default
	"Add a checkbox, name is autogenerated and default value is <default>.
	false is unchecked and true is checked."

	^self inputCheckbox: self nextVarName value: default

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 13:15'!
inputFile
	"Add an input file control so that a file can be chosen
	and included with the form. The form must be a multipart
	form - see #postFormMultiPart."

	^self inputFile: self nextVarName value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 13:16'!
inputFile: name
	"Add an input file control so that a file can be chosen
	and included with the form. The form must be a multipart
	form - see #postFormMultiPart."

	^self inputFile: name value: false

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 13:16'!
inputFile: name value: default 
	"Add an input file control so that a file can be chosen
	and included with the form. The form must be a multipart
	form - see #postFormMultiPart."

	^self addHtmlInput: (HVHtmlInputFile name: name value: (fields at: name ifAbsent:[default]))


! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 13:16'!
inputFileValue: default
	"Add an input file control so that a file can be chosen
	and included with the form. The form must be a multipart
	form - see #postFormMultiPart."

	^self inputFile: self nextVarName value: default

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:22'!
inputHidden
	"Add a hidden field, name is autogenerated and default value is ''."

	^self inputHidden: self nextVarName value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:23'!
inputHidden: name
	"Add a hidden field, use if you need to supply your own name.
	Default value is ''."

	^self inputHidden: name value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:23'!
inputHidden: var value: default 
	"Add a hidden field named <name> with default value <default>.
	The value should be a String. If the current request has
	posted this field then the value is picked from there."

	^self addHtmlInput: (HVHtmlInputHidden name: var value: (fields at: var ifAbsent:[default]))

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:24'!
inputHiddenValue: default
	"Add a hidden field, name is autogenerated and default value is <default>.
	The value should be a String."

	^self inputHidden: self nextVarName value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:57'!
inputNumber
	"Add a number field, name is autogenerated and default value is 0."

	^self inputNumber: self nextVarName value: 0

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:58'!
inputNumber: name
	"Add a number field, use if you need to supply your own name.
	Default value is 0."

	^self inputNumber: name value: 0

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 13:58'!
inputNumber: name size: size
	"Add a number field, use if you need to supply
	your own name and size of field. Default value is 0."

	^self inputNumber: name size: size value: 0
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:00'!
inputNumber: name size: size value: default 
	"Add a number field named <name> with default value <default>
	and length of field to be <size>.
	The value should be a Number. If the current request has
	posted this field then the value is picked from there."

	^self addHtmlInput: (HVHtmlInputNumber name: name value:
		(fields at: name ifAbsent:[default ifNil: [0]]) size: size)

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:01'!
inputNumber: name value: value
	"Add a number field, use if you need to supply your own name
	and default value, which should be a Number. Size defaults to 20."

	^self inputNumber: name size: 20 value: value

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:02'!
inputNumberSize: size
	"Add a number field with size <size>, name is autogenerated and default value is 0."

	^self inputNumber: self nextVarName size: size value: 0
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:02'!
inputNumberSize: size value: default
	"Add a number field with size <size> and default value <default>
	which should be a Number. Name is autogenerated."

	^self inputNumber: self nextVarName size: size value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:03'!
inputNumberValue: default
	"Add a number field with default value <default> which should
	be a Number. Size defaults to 20 and name is autogenerated."

	^self inputNumber: self nextVarName size: 20 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 14:04'!
inputPassword
	"Add a password field which is like a text field that does not
	show the entered characters. Name is autogenerated and default value is ''."

	^self inputPassword: self nextVarName value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:01'!
inputPassword: name

	^self inputPassword: name value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:01'!
inputPassword: name size: size

	^self inputPassword: name size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/4/2002 17:38'!
inputPassword: name size: size value: default 

	^self addHtmlInput: (HVHtmlInputPassword name: name value: (fields at: name ifAbsent:[default]) size: size)


! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:02'!
inputPassword: name value: default

	^self inputPassword: name size: 30 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/4/2002 17:38'!
inputPasswordSize: size

	^self inputPassword: self nextVarName size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/17/2003 13:33'!
inputRadio
	"Add a radio button, name is picked from previous
	radio button unless it has been explicitly closed with #endRadio.
	In that case we generate a new name."

	^self inputRadioValue: false! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/17/2003 13:42'!
inputRadio: name value: default id: id
	"Add a radio button named <name> with id <id>.
	The id should be a unique String. If the current request has
	posted this field then the value is calculated from
	there, otherwise we use the supplied Boolean <default>.
	If one of the radio buttons in the current group already is
	set then we ignore <default> and use false."

	| val radio |
	val _ default.
	self ifSubmit: [
		val _ (fields includesKey: name)
			ifTrue:[ (fields at: name) = id asString ]
			ifFalse: [ false ]].
	"If there was a radio button before us, make sure we only use
	true if noone has been true so far:"
	val _ lastRadio ifNotNil: [lastRadio nooneSet and: [val]] ifNil: [val].
	radio _ HVHtmlInputRadio name: name value: val id: id.
	radio previous: lastRadio.
	lastRadio _ radio.
	^self addHtmlInput: radio! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/16/2003 17:51'!
inputRadioValue: default
	"Add a radio button, name is picked from previous
	radio button unless it has been explicitly closed with #endRadio.
	In that case we generate a new name. Default value is <default>."

	| name id |
	(lastRadio isNil or: [lastRadio isClosed])
		ifTrue: [name _ self nextVarName. id _ 1]
		ifFalse: [name _ lastRadio name. id _ lastRadio id + 1].
	^self inputRadio: name value: default id: id
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 00:10'!
inputText

	^self inputText: self nextVarName value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 1/31/2002 15:55'!
inputText: var

	^self inputText: var value: ''

! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/5/2002 09:20'!
inputText: var size: size

	^self inputText: var size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/22/2002 13:58'!
inputText: name size: size value: default 

	^self addHtmlInput: (HVHtmlInputText name: name value: (fields at: name ifAbsent:[default]) size: size)


! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:37'!
inputText: var value: default

	^self inputText: var size: 30 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/15/2002 14:00'!
inputTextSize: size

	^self inputText: self nextVarName size: size value: ''
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'JO 3/4/2002 14:13'!
inputTextSize: size value: default

	^self inputText: self nextVarName size: size value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/21/2002 15:58'!
inputTextValue: default

	^self inputText: self nextVarName value: default

! !

!HVHtmlBuilder methodsFor: 'html-forms-queries' stamp: 'gh 9/16/2002 14:44'!
isPost
	"Is it a POST?"

	^request isPostRequest! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:15'!
lightGreyRow
	self halt! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/17/2003 11:03'!
link: url text: anObject
	"Add a HTML link."

	^self anchorWithUrl: url do: anObject! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/10/2003 10:37'!
linkBack
	"Add a back link to the default page of this view."

	^self linkDefault! !

!HVHtmlBuilder methodsFor: 'deprecated' stamp: 'gk 3/2/2004 16:14'!
linkBack: text
	"Add a link to the default page of this view."

	self deprecatedExplanation: 'Use linkDefault: instead'.
	^self link: view defaultUrl text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/10/2003 10:38'!
linkBackParent
	"Add a link to the default page of the parent view."

	^self linkBackParent: 'Back'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/10/2003 10:39'!
linkBackParent: text
	"Add a back link to the default page of the parent view."

	^self link: view parent defaultUrl text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/10/2003 10:37'!
linkDefault
	"Add a back link to the default page of this view."

	^self link: self defaultUrl text: 'Back'! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 3/2/2004 16:15'!
linkDefault: text
	"Add a link to the default page of this view."

	^self link: view defaultUrl text: text! !

!HVHtmlBuilder methodsFor: 'html-links' stamp: 'gk 12/10/2003 10:39'!
linkLocal: relativeUrl text: text
	"Add a local link to the view."

	^self link: (view urlFor: relativeUrl) text: text! !

!HVHtmlBuilder methodsFor: 'deprecated' stamp: 'gk 12/10/2003 10:26'!
linkPrefix: prefix text: text
	"Embed a link to the view with that prefix."

	| target |
	self deprecatedExplanation: 'Method deprecated since it breaks the principle of having the views unknowledgeable about the url paths. Use #parentsDo: or something instead.'.

	target _ view.
	[target prefix = prefix ifTrue:[ ^self link: target prefix text: text ].
	target _ target parent.
	target notNil] whileTrue.
	^self link: prefix text: 'No view found for this link'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:25'!
nbsp
	^self space! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 5/14/2002 10:24'!
nextVarName
	"The current Form enumerates it's own variables."

	^self currentForm nextVarName
! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gh 6/12/2002 10:40'!
numberAt: var ifAbsent: block
	"Customized version to get an expected number."

	^(fields at: var ifAbsent: [^block value]) asNumber! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 4/24/2002 14:11'!
ol: items
	"Make an ordered list by using asString on the elements."
	
	^self ol: items do: [:i | self html: i asString ]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:31'!
ol: items do: aBlock
	"Make an ordered list."
	
	^self tag: 'ol' do: [
		items do: [:i |
			self tag: 'li' doValue: [aBlock value: i]]]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:31'!
ol: items extract: aBlock
	"Make an ordered list with the value of the block
	rendered as the item, use #ol:do: for stuff where
	the block can not return something to be rendered."
	
	^self tag: 'ol' do: [
		items do: [:i |
			self tag: 'li' do: [aBlock value: i]]]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/11/2003 09:10'!
olDo: items
	"Make an ordered list by using value on each element."
	
	^self ol: items do: [:bl | bl value ]! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:16'!
p
	^self openTag: 'p'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:00'!
p: anObject
	^self paragraph: anObject! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/16/2003 16:56'!
postForm
	"Start a POST form with an action url that is the same as this request."

	^self addForm: (HVHtmlForm postAction: request url)! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/16/2003 16:56'!
postFormLocal: aString
	"Start a POST form with an action url based on the local view."

	^self addForm: (HVHtmlForm postAction: (view urlFor: aString))! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 10/3/2002 17:32'!
postFormMultiPart
	"Start a POST form with an action url that is
	the same as this request and with encoding as multi part."

	^self addForm: (HVHtmlForm postAction: request url enctype: 'multipart/form-data')! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/16/2003 16:56'!
postFormMultiPartLocal: aString
	"Start a POST form with an action url that is
	based on the view and with encoding as multi part."

	^self addForm: (HVHtmlForm postAction: (view urlFor: aString) enctype: 'multipart/form-data')! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 10:12'!
pre: anObject
	^self tag: 'pre' do: anObject! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/11/2003 11:33'!
radio: aName objects: objects value: default
	^self radio: aName objects: objects values: nil nilLabel: #None selector: nil value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/11/2003 11:39'!
radio: aName objects: objects values: values nilLabel: label selector: sel value: default
	"Radio groups always have values that are integers from 1.
	If there is a value submitted we find the object at that
	position, otherwise we use the supplied default value."

	| val submitted v |
	submitted _ fields at: aName ifAbsent:[nil].
	submitted
		ifNotNil: [
			values
				ifNil: [
					(submitted isString not)
						ifTrue:[val _ OrderedCollection new.
							submitted isString ifTrue: [
								submitted _ submitted findTokens: Character space].
							submitted
								do: [:subm |
									v _ objects at: subm asNumber ifAbsent: [nil].
									v ifNotNil: [val add: v]]]
						ifFalse:[val _ objects at: submitted asNumber ifAbsent: [nil]]]
				ifNotNil: [
					val _ submitted.
					(val = 'nil') ifTrue:[val _ nil].
					]]
		ifNil: [val _ default].
	^self addHtmlInput: (HVHtmlRadioGroup name: aName objects: objects values: values nilLabel: label selector: sel value: val)
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/11/2003 11:40'!
radioGroup: objects

	^self radio: self nextVarName objects: objects value: (objects first)! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:24'!
red: anObject
	^self attributeAt: 'color' put: 'red'; tag: 'font' do: anObject! !

!HVHtmlBuilder methodsFor: 'redirection' stamp: 'gk 3/4/2004 14:31'!
redirectTo: url
	"Make a redirection to another url."

	^view redirectTo: url! !

!HVHtmlBuilder methodsFor: 'redirection' stamp: 'gk 3/4/2004 14:31'!
redirectToDefault
	"Make a redirection to the default url of the view."

	^view redirectToDefault! !

!HVHtmlBuilder methodsFor: 'redirection' stamp: 'gk 3/4/2004 14:32'!
redirectToLocal: page
	"Make a redirection to another page in the view,
	equaling another method in the view class."

	^view redirectToLocal: page! !

!HVHtmlBuilder methodsFor: 'private' stamp: 'gk 12/17/2003 11:22'!
render
	"Concatenate everything together and substituting variables
	in the progress. First we check if we are timing this page.
	If we are then we need to calculate the stop time and incorporate
	the time at the bottom of the page."

	^document contents contents

"	| start stream |
	start _ request propertyAt: #startTime ifAbsent: [nil].
	start ifNotNil: [elements removeLast ].
	stream _ WriteStream on: (String new: 50000).
	elements do: [:element |
		(element isKindOf: String)
			ifTrue:[ stream nextPutAll: element ]
			ifFalse:[ element renderFullOn: stream ]].
	start ifNotNil: [
		stream nextPutAll: '<br><font size=-1>Time in ms: ', (Time millisecondClockValue - start) asString, '</font>', String crlf.
		^stream contents
	].
	^stream contents"

! !

!HVHtmlBuilder methodsFor: 'accessing' stamp: 'gh 9/12/2002 16:02'!
request
	^request! !

!HVHtmlBuilder methodsFor: 'initialize-release' stamp: 'gk 12/17/2003 13:13'!
request: aRequest view: aView

	view _ aView.
	request _ aRequest.
	request isPostRequest
		ifTrue: [fields _ request postFields]
		ifFalse: [fields _ request getFields].
	document _ WVHtmlDocument new.
	variables _ Dictionary new! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:12'!
reset

	^self reset: 'Reset'
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 12/17/2003 12:23'!
reset: text

	^self attributeAt: 'value' put: text;
		attributeAt: 'type' put: 'reset';
		tag: 'input'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:16'!
row
	^self openTag: 'tr'! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/22/2002 17:46'!
select: aName objects: objects nilLabel: label value: default

	^self select: aName objects: objects size: 1 nilLabel: label value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:11'!
select: aName objects: objects size: size nilLabel: label value: default
	"Selects always have values that are integers from 1.
	If there is a value submitted we find the object at that
	position, otherwise we use the supplied default value."

	^self select: aName objects: objects values: nil size: size multiple: false nilLabel: label selector: nil value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:14'!
select: aName objects: objects size: size value: default
	^self select: aName objects: objects values: nil size: size multiple: false nilLabel: #None selector: nil value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 12:46'!
select: aName objects: objects value: default

	^self select: aName objects: objects size: 1 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/4/2003 21:32'!
select: aName objects: objects values: values size: size multiple: multi nilLabel: label selector: sel value: default
	"Selects always have values that are integers from 1.
	If there is a value submitted we find the object at that
	position, otherwise we use the supplied default value."

	| val submitted v |
	submitted _ fields at: aName ifAbsent:[nil].
	submitted
		ifNotNil: [
			values
				ifNil: [
					(submitted isString not | multi)
						ifTrue:[val _ OrderedCollection new.
							submitted isString ifTrue: [
								submitted _ submitted findTokens: Character space].
							submitted
								do: [:subm |
									v _ objects at: subm asNumber ifAbsent: [nil].
									v ifNotNil: [val add: v]]]
						ifFalse:[val _ objects at: submitted asNumber ifAbsent: [nil]]]
				ifNotNil: [
					multi
						ifTrue: [submitted isString ifTrue: [
									submitted _ submitted findTokens: Character space].
								val _ submitted]
						ifFalse: [val _ submitted].
					(val = 'nil') ifTrue:[val _ nil].
					]]
		ifNil: [val _ default].
	^self addHtmlInput: (HVHtmlSelect name: aName objects: objects values: values size: size multiple: multi nilLabel: label selector: sel value: val)
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/4/2003 21:29'!
selectMulti: aName objects: objects size: size value: default
	^self select: aName objects: objects values: nil size: size multiple: true nilLabel: #None selector: nil value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/10/2003 14:39'!
selectMultiObjects: objects

	^self selectMulti: self nextVarName objects: objects size: 10 value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/10/2003 14:39'!
selectMultiObjects: objects selector: aSymbol

	^self select: self nextVarName objects: objects values: nil size: 10 multiple: true nilLabel: #None selector: aSymbol value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/10/2003 23:58'!
selectMultiObjects: objects size: sz

	^self selectMulti: self nextVarName objects: objects size: sz value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 5/6/2004 16:02'!
selectMultiObjects: objects size: sz value: default

	^self selectMulti: self nextVarName objects: objects size: sz value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/10/2003 14:40'!
selectMultiObjects: objects value: default

	^self selectMulti: self nextVarName objects: objects size: 10 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 12:49'!
selectObjects: objects

	^self select: self nextVarName objects: objects size: 1 value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:14'!
selectObjects: objects selector: aSymbol

	^self select: self nextVarName objects: objects values: nil size: 1 multiple: false nilLabel: #None selector: aSymbol value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 5/11/2004 14:24'!
selectObjects: objects selector: aSymbol value: default

	^self select: self nextVarName objects: objects values: nil size: 1 multiple: false nilLabel: #None selector: aSymbol value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/11/2003 15:38'!
selectObjects: objects size: sz

	^self select: self nextVarName objects: objects size: sz value: nil
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 12:46'!
selectObjects: objects value: default

	^self select: self nextVarName objects: objects size: 1 value: default
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 12:57'!
selectObjectsFirstSelected: objects

	^self select: self nextVarName objects: objects size: 1 value: (objects isEmpty ifTrue:[nil] ifFalse:[objects first])! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:15'!
selectObjectsFirstSelected: objects selector: sel

	^self select: self nextVarName objects: objects values: nil size: 1 multiple: false nilLabel: #None selector: sel value: (objects isEmpty ifTrue:[nil] ifFalse:[objects first])! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:15'!
selectObjectsFirstSelected: objects values: values

	^self select: self nextVarName objects: objects values: values size: 1 multiple: false nilLabel: #None selector: nil value: (objects isEmpty ifTrue:[nil] ifFalse:[values first])! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/7/2003 14:03'!
selectObjectsNilFirst: objects

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) size: 1 value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/7/2003 14:03'!
selectObjectsNilFirst: objects nilLabel: label

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) size: 1 nilLabel: label value: nil! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 8/15/2003 15:15'!
selectObjectsNilFirst: objects nilLabel: label selector: sel value: default

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) values: nil size: 1 multiple: false nilLabel: label selector: sel value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/21/2002 16:15'!
selectObjectsNilFirst: objects nilLabel: label value: default

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) size: 1 nilLabel: label value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 5/16/2002 14:39'!
selectObjectsNilFirst: objects value: default

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) size: 1 value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 11/7/2003 14:03'!
selectObjectsNilFirst: objects values: values nilLabel: label

	^self select: self nextVarName objects: (objects asOrderedCollection addFirst: nil; yourself) values: (values asOrderedCollection addFirst: nil; yourself) size: 1 multiple: false nilLabel: label selector: nil value: nil! !

!HVHtmlBuilder methodsFor: 'hacks' stamp: 'gk 12/17/2003 11:01'!
srcLink
	"Adds a link showing the source code of the current method.
	Used for examples etc."

	| url |
	url _ view urlStream pathWithPrefix: #src.
	url = '/src' ifTrue: [url _ '/srcdefault'].
	^self attributeAt: 'size' put: '-1';
		tag: 'font' do: [
			self link: url text: 'See source for this page']! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 5/18/2004 11:46'!
start
	"Start the HTML page, by default we just add the title
	and make it XHTML etc."

	document headDo: [ self tag: 'title' do: view title]! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:12'!
submit

	^self submit: 'Submit'
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 15:08'!
submit: text

	^self submit: self nextVarName value: text
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/29/2003 15:47'!
submit: name value: text

	| val |
	val _ false.
	self ifSubmit: [
		val _ (fields includesKey: name)
			ifTrue:[ (fields at: name) = text ]
			ifFalse: [ false ]].
	^self addHtmlInput: (HVHtmlInputSubmit name: name value: text pressed: val)! !

!HVHtmlBuilder methodsFor: 'html-forms-queries' stamp: 'gk 11/7/2003 12:45'!
submitted: aString
	"Low level access - is a certain field available?
	To check for button presses, keep the button and
	use #ifPressed: or #pressed."

	^(fields detect: [:oc | oc includes: aString] ifNone: [nil]) notNil! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:16'!
tab
	self halt! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 10:18'!
table
	self attributeAt: 'border' put: '0'.
	self openTag: 'table'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 5/18/2004 15:36'!
table: objects heads: heads block: aBlock
	"Add a table. Efficient implementation but the extraction
	block <aBlock> can not use the builder."

	self table: [
		self heads: heads.
		self tableBody: [
			objects do: [:obj |
				self tableRow: [
					(aBlock value: obj) do: [:val |
						self tableData: val asString ]
				]
			]
		]
	]! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 13:12'!
table: objects heads: heads cellBlock: aBlock
	"Add a table. This version takes a 2-argument (object and builder)
	block which feeds the cell values into the builder using #cell:."

self halt.! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 5/18/2004 14:12'!
tableBody
	self openTag: 'tbody'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 5/18/2004 15:35'!
tableHead
	self openTag: 'thead'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 13:12'!
tableHeads: heads
	"Add a table. Use #row, #cell, #endRow, #endCell, #endTable."

	self table; heads: heads! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:05'!
tag: tag around: anObject
	self tag: tag do: anObject! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 11:42'!
td
	^self openTag: 'td'! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 10/31/2003 11:37'!
textArea

	^self textArea: self nextVarName rows: 5 cols: 40 value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/16/2002 01:07'!
textArea: name

	^self textArea: name rows: 5 cols: 40 value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 2/1/2002 13:32'!
textArea: var rows: rows cols: cols

	^self textArea: var rows: rows cols: cols value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/19/2002 21:01'!
textArea: name rows: rows cols: cols value: default

	^self addHtmlInput: (HVHtmlTextArea name: name rows: rows cols: cols value: (fields at: name ifAbsent:[default]))
! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 5/12/2004 12:06'!
textArea: var value: default

	^self textArea: var rows: 5 cols: 40 value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 3/19/2002 21:06'!
textAreaRows: rows cols: cols

	^self textArea: self nextVarName rows: rows cols: cols value: ''! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gh 7/31/2002 09:33'!
textAreaRows: rows cols: cols value: default

	^self textArea: self nextVarName rows: rows cols: cols value: default! !

!HVHtmlBuilder methodsFor: 'html-forms' stamp: 'gk 5/12/2004 12:06'!
textAreaValue: default

	^self textArea: self nextVarName rows: 5 cols: 40 value: default! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 11:38'!
title: anObject
	^self tag: 'title' do: anObject! !

!HVHtmlBuilder methodsFor: 'special-toc' stamp: 'gh 9/12/2002 13:17'!
toc
	"Return an empty table of contents."

	^self tocValue: nil
! !

!HVHtmlBuilder methodsFor: 'special-toc' stamp: 'gk 12/17/2003 12:32'!
toc: aName value: aValue
	"Return a table of contents with a given name and value."

	| var |
	var _ HVTableOfContents name: aName value: aValue builder: self.
	variables at: aName put: var.
	^document addElement: var

! !

!HVHtmlBuilder methodsFor: 'special-toc' stamp: 'gh 9/12/2002 13:21'!
tocValue: aValue
	"Return a table of contents with a given value."

	^self toc: variables size fullPrintString value: aValue

! !

!HVHtmlBuilder methodsFor: 'html-alignment' stamp: 'gk 12/17/2003 11:42'!
tr
	^self openTag: 'tr'! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gh 4/24/2002 14:11'!
ul: items
	"Make an unordered list by using asString on the elements."
	
	^self ul: items do: [:i | self html: i asString ]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/17/2003 12:32'!
ul: items do: aBlock
	"Make an unordered list but we let the block
	add the item to the builder itself."

	^self tag: 'ul' do: [
		items do: [:i |
			self tag: 'li' doValue: [aBlock value: i]]]! !

!HVHtmlBuilder methodsFor: 'html' stamp: 'gk 12/11/2003 09:10'!
ulDo: items
	"Make an unordered list by using value on each element."
	
	^self ul: items do: [:bl | bl value ]! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 3/15/2002 21:35'!
var
	"Return a variable node. The name will be a single number.
	A variable node can be given content using #value:
	later on after the page has been built but before it is rendered."

	^self var: (variables size fullPrintString) value: ''
! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gh 2/22/2002 13:07'!
var: aName
	"Return a variable node.
	A variable node can be given content using #value:
	later on after the page has been built."

	^self var: aName value: ''
! !

!HVHtmlBuilder methodsFor: 'variables' stamp: 'gk 12/17/2003 10:13'!
var: aName value: aValue
	"Return a variable node.
	A variable node can be given content using #value:
	later on after the page has been built."

	| var |
	var _ HVSimpleVariable name: aName value: aValue.
	variables at: aName put: var.
	^document addElement: var

! !

!HVHtmlBuilder methodsFor: 'accessing' stamp: 'gh 10/18/2002 15:30'!
view
	^view! !

!HVHtmlBuilder methodsFor: 'buttons' stamp: 'gk 5/18/2004 15:28'!
xhtmlButton

	self text: '<div class="w3cbutton1"><a class="w3c1" href="http://www.w3.org/">W3C</a><a class="spec1" href="http://validator.w3.org/check/referer">XHTML 1.0</a></div>'! !

!HVHtmlBuilder methodsFor: 'html-tables' stamp: 'gk 12/17/2003 12:10'!
zebraTable: objects heads: heads block: aBlock
	"Add a table. Efficient implementation but the extraction
	block <aBlock> can not use the builder."

self halt! !

!SocketStream methodsFor: '*hv-fixes' stamp: 'JO 5/14/2002 16:13'!
isEmpty
	"Test if there are more data to read"
	^inStream isEmpty and: [self isDataAvailable not]! !

!SocketStream methodsFor: '*hv-fixes' stamp: 'gk 10/24/2003 15:43'!
match: aString
	"Position past the occurrence of aString
	if aString is matched at current position.
	If it is not matched the position is not changed.
	Answer true if found, false otherwise."

	| oldPos |
	self receiveData: aString size.
	oldPos _ inStream position.
	(inStream match: aString)
		ifTrue: [
			inStream position: oldPos.
			self next: aString size.
			^true]
		ifFalse: [
			inStream position: oldPos.
			^false]! !

!SocketStream methodsFor: '*hv-fixes' stamp: 'gk 10/24/2003 15:42'!
nextChunk
	"Return some data. If there is data in the inStream
	we return that, otherwise we receive some data and
	recursively try again."

	self inStream atEnd ifFalse: [^self inStream upToEnd].
	self receiveData.
	^self nextChunk! !

!SocketStream methodsFor: '*hv-fixes' stamp: 'gk 10/24/2003 14:16'!
receiveData: nBytes
	"Keep reading the socket until we have nBytes in the inStream."

	[self atEnd not and: [self inStream size < nBytes]]
		whileTrue: [self receiveData]! !

!SocketStream methodsFor: '*hv-fixes' stamp: 'mir 5/9/2003 18:17'!
upTo: delim 
	| resultStream nextChar |
	resultStream _ WriteStream on: (String new: 100).

	[(nextChar _ self next) = delim]
		whileFalse: [
			nextChar
				ifNil: [^resultStream contents]
				ifNotNil: [resultStream nextPut: nextChar]].

	^resultStream contents! !

!HttpRequest methodsFor: '*hv-fixes' stamp: 'gk 11/3/2003 13:14'!
isPostMultipart
	"Is this request a POST with multipart form data?"

	^self isPostRequest and: [self contentType = MIMEDocument contentTypeMultipart]! !
HVHttpView initialize!
